/* A Bison parser, made by GNU Bison 2.0.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Using locations.  */
#define YYLSP_NEEDED 0






/* Copy the first part of user declarations.  */
#line 27 "lscp.y"


#include "lscpparser.h"
#include "lscpserver.h"
#include "lscpevent.h"

// to save us typing work in the rules action definitions
#define LSCPSERVER ((yyparse_param_t*) yyparse_param)->pServer

// clears input buffer
void restart(yyparse_param_t* pparam, int& yychar);
#define RESTART restart((yyparse_param_t*) YYPARSE_PARAM, yychar)

// we provide our own version of yyerror() so we don't have to link against the yacc library
void yyerror(const char* s);

static char buf[1024]; // input buffer to feed the parser with new characters
static int bytes = 0;  // current number of characters in the input buffer
static int ptr   = 0;  // current position in the input buffer

// external reference to the function which actually reads from the socket
extern int GetLSCPCommand( void *buf, int max_size);

// custom scanner function which reads from the socket
int yylex(YYSTYPE* yylval) {
    // check if we have to read new characters
    if (ptr >= bytes) {
        bytes = GetLSCPCommand(buf, 1023);
        ptr   = 0;
        if (bytes < 0) {
            bytes = 0;
            return 0;
        }
    }
    return (int) buf[ptr++];
}



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
typedef int YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 213 of yacc.c.  */
#line 121 "y.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   else
#    define YYSTACK_ALLOC alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE))			\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  40
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   4477

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  227
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  97
/* YYNRULES -- Number of rules. */
#define YYNRULES  431
/* YYNRULES -- Number of states. */
#define YYNSTATES  1198

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   257

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     225,     2,     2,   226,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,   224,    73,     7,     3,    74,    75,    76,     6,
      77,    78,    79,     9,     5,    10,     8,    80,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    81,    82,
      83,     4,    84,    85,    86,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    87,    88,    89,    90,    91,     2,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    92,    93,    94,    95,     2,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,     1,     2
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short int yyprhs[] =
{
       0,     0,     3,     6,    10,    11,    13,    15,    17,    19,
      22,    25,    28,    31,    35,    39,    43,    47,    51,    55,
      61,    65,    69,    73,    77,    83,    85,    87,    89,    91,
      93,    95,    97,    99,   101,   103,   105,   107,   109,   111,
     113,   115,   121,   129,   139,   141,   147,   155,   165,   167,
     169,   175,   181,   189,   199,   207,   217,   219,   225,   233,
     239,   245,   251,   255,   263,   273,   281,   291,   295,   299,
     305,   309,   315,   319,   323,   327,   331,   335,   341,   349,
     355,   365,   371,   377,   383,   389,   395,   401,   407,   411,
     417,   419,   421,   423,   425,   427,   429,   431,   433,   439,
     447,   451,   453,   455,   457,   459,   461,   463,   465,   467,
     469,   471,   473,   475,   477,   479,   483,   485,   489,   493,
     495,   497,   499,   501,   503,   506,   510,   515,   520,   522,
     525,   527,   529,   531,   533,   535,   537,   539,   541,   543,
     545,   547,   550,   553,   556,   559,   562,   565,   568,   571,
     574,   576,   578,   580,   582,   584,   586,   588,   590,   592,
     594,   596,   598,   600,   602,   604,   606,   608,   610,   612,
     614,   616,   618,   620,   622,   624,   626,   628,   630,   632,
     634,   636,   638,   640,   642,   644,   646,   648,   650,   652,
     654,   656,   658,   660,   662,   664,   666,   668,   670,   672,
     674,   676,   678,   680,   682,   684,   686,   688,   690,   692,
     694,   696,   698,   700,   702,   704,   706,   708,   710,   712,
     714,   716,   718,   720,   722,   724,   726,   728,   730,   732,
     734,   736,   738,   740,   742,   744,   746,   748,   750,   752,
     754,   756,   758,   760,   762,   764,   766,   768,   770,   772,
     774,   776,   778,   780,   782,   784,   786,   788,   790,   792,
     794,   796,   798,   800,   802,   804,   806,   808,   810,   812,
     814,   816,   818,   820,   822,   824,   826,   828,   830,   832,
     834,   836,   838,   840,   842,   844,   846,   848,   850,   852,
     854,   856,   858,   860,   862,   864,   866,   868,   870,   872,
     874,   876,   878,   880,   882,   884,   886,   888,   890,   892,
     894,   896,   898,   900,   902,   904,   906,   908,   910,   912,
     914,   916,   918,   920,   922,   924,   926,   928,   930,   932,
     934,   936,   938,   940,   942,   944,   946,   948,   950,   952,
     954,   956,   958,   960,   962,   964,   966,   968,   970,   972,
     974,   976,   978,   980,   982,   984,   986,   988,   990,   992,
     994,   996,   998,  1000,  1002,  1004,  1006,  1008,  1010,  1012,
    1014,  1016,  1019,  1022,  1026,  1030,  1032,  1034,  1036,  1040,
    1044,  1051,  1059,  1064,  1069,  1073,  1083,  1090,  1094,  1104,
    1116,  1123,  1131,  1149,  1180,  1189,  1194,  1208,  1221,  1233,
    1246,  1258,  1269,  1276,  1306,  1327,  1347,  1377,  1397,  1428,
    1449,  1467,  1496,  1524,  1550,  1569,  1587,  1615,  1633,  1649,
    1668,  1684,  1695,  1702,  1709,  1714,  1719,  1725,  1736,  1742,
    1756,  1761
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const short int yyrhs[] =
{
     228,     0,    -1,   229,   268,    -1,   229,   269,   268,    -1,
      -1,   230,    -1,   231,    -1,     1,    -1,     3,    -1,   230,
       3,    -1,   230,   267,    -1,   230,   263,    -1,   230,   259,
      -1,   270,   267,   283,    -1,   271,   267,   234,    -1,   272,
     267,   236,    -1,   273,   267,   237,    -1,   274,   267,   242,
      -1,   275,   267,   238,    -1,   278,   267,   283,   267,   252,
      -1,   279,   267,   235,    -1,   280,   267,   232,    -1,   281,
     267,   233,    -1,   282,   267,   265,    -1,   320,   267,   283,
     267,   252,    -1,   320,    -1,   323,    -1,   288,    -1,   292,
      -1,   291,    -1,   290,    -1,   289,    -1,   321,    -1,   288,
      -1,   292,    -1,   291,    -1,   290,    -1,   289,    -1,   321,
      -1,   284,    -1,   303,    -1,   309,   267,   287,   267,   259,
      -1,   308,   267,   287,   267,   259,   267,   259,    -1,   308,
     267,   287,   267,   259,   267,   259,   267,   240,    -1,   285,
      -1,   299,   267,   287,   267,   259,    -1,   298,   267,   287,
     267,   259,   267,   259,    -1,   298,   267,   287,   267,   259,
     267,   259,   267,   240,    -1,   296,    -1,   306,    -1,   297,
     267,   287,   267,   263,    -1,   307,   267,   287,   267,   263,
      -1,   310,   267,   287,   267,   263,   267,   263,    -1,   305,
     267,   287,   267,   263,   267,   263,   267,   259,    -1,   301,
     267,   287,   267,   263,   267,   263,    -1,   300,   267,   287,
     267,   263,   267,   263,   267,   259,    -1,   286,    -1,   283,
     267,   287,   267,   252,    -1,   283,   267,   290,   267,   241,
     267,   252,    -1,   283,   267,   291,   267,   252,    -1,   283,
     267,   292,   267,   252,    -1,   294,   267,   287,   267,   254,
      -1,   314,   267,   287,    -1,   295,   267,   263,   267,   259,
       4,   256,    -1,   300,   267,   263,   267,   263,   267,   259,
       4,   256,    -1,   304,   267,   263,   267,   259,     4,   256,
      -1,   305,   267,   263,   267,   263,   267,   259,     4,   256,
      -1,   283,   267,   239,    -1,   322,   267,   258,    -1,   297,
     267,   259,   267,   240,    -1,   297,   267,   259,    -1,   307,
     267,   259,   267,   240,    -1,   307,   267,   259,    -1,   297,
     267,   263,    -1,   307,   267,   263,    -1,   293,   267,   243,
      -1,   294,   267,   244,    -1,   297,   267,   252,   267,   245,
      -1,   301,   267,   252,   267,   246,   267,   246,    -1,   302,
     267,   252,   267,   247,    -1,   313,   267,   252,   267,   245,
     267,   248,   267,   249,    -1,   307,   267,   252,   267,   245,
      -1,   310,   267,   252,   267,   248,    -1,   311,   267,   252,
     267,   249,    -1,   312,   267,   252,   267,   250,    -1,   315,
     267,   252,   267,   251,    -1,   316,   267,   252,   267,   258,
      -1,   317,   267,   252,   267,   258,    -1,   259,     4,   256,
      -1,   240,   267,   259,     4,   256,    -1,   318,    -1,   319,
      -1,   296,    -1,   306,    -1,   286,    -1,   284,    -1,   303,
      -1,   285,    -1,   255,   267,   253,   267,   252,    -1,   277,
     267,   255,   267,   253,   267,   252,    -1,   254,   267,   252,
      -1,   263,    -1,   263,    -1,   259,    -1,   263,    -1,   263,
      -1,   276,    -1,   259,    -1,   260,    -1,   263,    -1,   263,
      -1,   263,    -1,   259,    -1,   266,    -1,   257,    -1,   256,
       5,   257,    -1,   259,    -1,     6,   259,     6,    -1,     7,
     259,     7,    -1,   263,    -1,   260,    -1,   263,    -1,   259,
      -1,   264,    -1,   259,   264,    -1,   261,     8,   261,    -1,
       9,   261,     8,   261,    -1,    10,   261,     8,   261,    -1,
     262,    -1,   261,   262,    -1,    11,    -1,    12,    -1,    13,
      -1,    14,    -1,    15,    -1,    16,    -1,    17,    -1,    18,
      -1,    19,    -1,    20,    -1,   262,    -1,    12,   261,    -1,
      13,   261,    -1,    14,   261,    -1,    15,   261,    -1,    16,
     261,    -1,    17,   261,    -1,    18,   261,    -1,    19,   261,
      -1,    20,   261,    -1,    21,    -1,    22,    -1,    23,    -1,
      24,    -1,    25,    -1,    26,    -1,    27,    -1,    28,    -1,
      29,    -1,    30,    -1,    31,    -1,    32,    -1,    33,    -1,
      34,    -1,    35,    -1,    36,    -1,    37,    -1,    38,    -1,
      39,    -1,    40,    -1,    41,    -1,    42,    -1,    43,    -1,
      44,    -1,    45,    -1,    46,    -1,    47,    -1,    48,    -1,
      49,    -1,    50,    -1,    51,    -1,    52,    -1,    53,    -1,
      54,    -1,    55,    -1,    56,    -1,    57,    -1,    58,    -1,
      59,    -1,    60,    -1,    61,    -1,    62,    -1,    63,    -1,
      64,    -1,    65,    -1,    66,    -1,    67,    -1,    68,    -1,
      69,    -1,    70,    -1,    71,    -1,    72,    -1,    11,    -1,
      12,    -1,    13,    -1,    14,    -1,    15,    -1,    16,    -1,
      17,    -1,    18,    -1,    19,    -1,    20,    -1,    73,    -1,
       3,    -1,    74,    -1,    75,    -1,    76,    -1,    77,    -1,
      78,    -1,    79,    -1,     9,    -1,    10,    -1,     8,    -1,
       5,    -1,    80,    -1,    81,    -1,    82,    -1,    83,    -1,
       4,    -1,    84,    -1,    85,    -1,    86,    -1,    87,    -1,
      88,    -1,    89,    -1,    90,    -1,    91,    -1,    92,    -1,
      93,    -1,    94,    -1,    95,    -1,    96,    -1,    97,    -1,
      98,    -1,    99,    -1,   100,    -1,   101,    -1,   102,    -1,
     103,    -1,   104,    -1,   105,    -1,   106,    -1,   107,    -1,
     108,    -1,   109,    -1,   110,    -1,   111,    -1,   112,    -1,
     113,    -1,   114,    -1,   115,    -1,   116,    -1,   117,    -1,
     118,    -1,   119,    -1,   120,    -1,   121,    -1,   122,    -1,
     123,    -1,   124,    -1,   125,    -1,   126,    -1,   127,    -1,
     128,    -1,   129,    -1,   130,    -1,   131,    -1,   132,    -1,
     133,    -1,   134,    -1,   135,    -1,   136,    -1,   137,    -1,
     138,    -1,   139,    -1,   140,    -1,   141,    -1,   142,    -1,
     143,    -1,   144,    -1,   145,    -1,   146,    -1,   147,    -1,
     148,    -1,   149,    -1,   150,    -1,   151,    -1,   152,    -1,
     153,    -1,   154,    -1,   155,    -1,   156,    -1,   157,    -1,
     158,    -1,   159,    -1,   160,    -1,   161,    -1,   162,    -1,
     163,    -1,   164,    -1,   165,    -1,   166,    -1,   167,    -1,
     168,    -1,   169,    -1,   170,    -1,   171,    -1,   172,    -1,
     173,    -1,   174,    -1,   175,    -1,   176,    -1,   177,    -1,
     178,    -1,   179,    -1,   180,    -1,   181,    -1,   182,    -1,
     183,    -1,   184,    -1,   185,    -1,   186,    -1,   187,    -1,
     188,    -1,   189,    -1,   190,    -1,   191,    -1,   192,    -1,
     193,    -1,   194,    -1,   195,    -1,   196,    -1,   197,    -1,
     198,    -1,   199,    -1,   200,    -1,   201,    -1,   202,    -1,
     203,    -1,   204,    -1,   205,    -1,   206,    -1,   207,    -1,
     208,    -1,   209,    -1,   210,    -1,   211,    -1,   212,    -1,
     213,    -1,   214,    -1,   215,    -1,   216,    -1,   217,    -1,
     218,    -1,   219,    -1,   220,    -1,   221,    -1,   222,    -1,
     223,    -1,   267,    -1,   259,    -1,   265,   267,    -1,   265,
     259,    -1,     6,   265,     6,    -1,     7,   265,     7,    -1,
     224,    -1,   225,    -1,   226,    -1,    21,    24,    24,    -1,
      27,    25,    40,    -1,    23,    38,    25,    21,    40,    25,
      -1,    24,    25,    39,    40,    38,    35,    45,    -1,    32,
      29,    39,    40,    -1,    32,    35,    21,    24,    -1,    21,
      32,    32,    -1,    34,    35,    34,    91,    33,    35,    24,
      21,    32,    -1,    38,    25,    33,    35,    42,    25,    -1,
      39,    25,    40,    -1,    39,    41,    22,    39,    23,    38,
      29,    22,    25,    -1,    41,    34,    39,    41,    22,    39,
      23,    38,    29,    22,    25,    -1,    39,    25,    32,    25,
      23,    40,    -1,    23,    28,    21,    34,    34,    25,    32,
      -1,    21,    42,    21,    29,    32,    21,    22,    32,    25,
      91,    25,    34,    27,    29,    34,    25,    39,    -1,    21,
      42,    21,    29,    32,    21,    22,    32,    25,    91,    21,
      41,    24,    29,    35,    91,    35,    41,    40,    36,    41,
      40,    91,    24,    38,    29,    42,    25,    38,    39,    -1,
      23,    28,    21,    34,    34,    25,    32,    39,    -1,    29,
      34,    26,    35,    -1,    23,    28,    21,    34,    34,    25,
      32,    91,    23,    35,    41,    34,    40,    -1,    23,    28,
      21,    34,    34,    25,    32,    91,    29,    34,    26,    35,
      -1,    22,    41,    26,    26,    25,    38,    91,    26,    29,
      32,    32,    -1,    39,    40,    38,    25,    21,    33,    91,
      23,    35,    41,    34,    40,    -1,    42,    35,    29,    23,
      25,    91,    23,    35,    41,    34,    40,    -1,    29,    34,
      39,    40,    38,    41,    33,    25,    34,    40,    -1,    25,
      34,    27,    29,    34,    25,    -1,    21,    41,    24,    29,
      35,    91,    35,    41,    40,    36,    41,    40,    91,    24,
      25,    42,    29,    23,    25,    91,    36,    21,    38,    21,
      33,    25,    40,    25,    38,    -1,    21,    41,    24,    29,
      35,    91,    35,    41,    40,    36,    41,    40,    91,    24,
      25,    42,    29,    23,    25,    39,    -1,    21,    41,    24,
      29,    35,    91,    35,    41,    40,    36,    41,    40,    91,
      24,    25,    42,    29,    23,    25,    -1,    21,    41,    24,
      29,    35,    91,    35,    41,    40,    36,    41,    40,    91,
      24,    38,    29,    42,    25,    38,    91,    36,    21,    38,
      21,    33,    25,    40,    25,    38,    -1,    21,    41,    24,
      29,    35,    91,    35,    41,    40,    36,    41,    40,    91,
      24,    38,    29,    42,    25,    38,    -1,    21,    41,    24,
      29,    35,    91,    35,    41,    40,    36,    41,    40,    91,
      23,    28,    21,    34,    34,    25,    32,    91,    36,    21,
      38,    21,    33,    25,    40,    25,    38,    -1,    21,    41,
      24,    29,    35,    91,    35,    41,    40,    36,    41,    40,
      91,    23,    28,    21,    34,    34,    25,    32,    -1,    21,
      41,    24,    29,    35,    91,    35,    41,    40,    36,    41,
      40,    91,    40,    45,    36,    25,    -1,    21,    42,    21,
      29,    32,    21,    22,    32,    25,    91,    33,    29,    24,
      29,    91,    29,    34,    36,    41,    40,    91,    24,    38,
      29,    42,    25,    38,    39,    -1,    33,    29,    24,    29,
      91,    29,    34,    36,    41,    40,    91,    24,    25,    42,
      29,    23,    25,    91,    36,    21,    38,    21,    33,    25,
      40,    25,    38,    -1,    33,    29,    24,    29,    91,    29,
      34,    36,    41,    40,    91,    36,    35,    38,    40,    91,
      36,    21,    38,    21,    33,    25,    40,    25,    38,    -1,
      33,    29,    24,    29,    91,    29,    34,    36,    41,    40,
      91,    24,    25,    42,    29,    23,    25,    39,    -1,    33,
      29,    24,    29,    91,    29,    34,    36,    41,    40,    91,
      24,    25,    42,    29,    23,    25,    -1,    33,    29,    24,
      29,    91,    29,    34,    36,    41,    40,    91,    24,    38,
      29,    42,    25,    38,    91,    36,    21,    38,    21,    33,
      25,    40,    25,    38,    -1,    33,    29,    24,    29,    91,
      29,    34,    36,    41,    40,    91,    24,    38,    29,    42,
      25,    38,    -1,    33,    29,    24,    29,    91,    29,    34,
      36,    41,    40,    91,    36,    35,    38,    40,    -1,    33,
      29,    24,    29,    91,    29,    34,    36,    41,    40,    91,
      23,    28,    21,    34,    34,    25,    32,    -1,    33,    29,
      24,    29,    91,    29,    34,    36,    41,    40,    91,    40,
      45,    36,    25,    -1,    33,    29,    24,    29,    91,    29,
      34,    36,    41,    40,    -1,    39,    25,    38,    42,    25,
      38,    -1,    42,    35,    32,    41,    33,    25,    -1,    33,
      41,    40,    25,    -1,    39,    35,    32,    35,    -1,    22,
      45,    40,    25,    39,    -1,    36,    25,    38,    23,    25,
      34,    40,    21,    27,    25,    -1,    38,    25,    39,    25,
      40,    -1,    33,    29,    39,    23,    25,    32,    32,    21,
      34,    25,    35,    41,    39,    -1,    25,    23,    28,    35,
      -1,    37,    41,    29,    40,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,    90,    90,    91,    94,    95,    96,    97,   100,   101,
     102,   103,   104,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   123,   124,   125,
     126,   127,   128,   131,   132,   133,   134,   135,   136,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   165,   166,   167,   168,   169,   170,   173,
     174,   175,   176,   179,   180,   183,   184,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   200,   201,
     204,   205,   208,   209,   210,   211,   212,   213,   216,   217,
     220,   223,   226,   229,   232,   235,   236,   239,   242,   243,
     246,   249,   252,   255,   258,   259,   262,   263,   264,   265,
     266,   274,   275,   278,   279,   282,   283,   284,   288,   289,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     315,   315,   315,   315,   315,   315,   315,   315,   315,   315,
     315,   315,   315,   315,   315,   315,   315,   315,   315,   315,
     315,   315,   315,   315,   315,   315,   316,   316,   316,   316,
     316,   316,   316,   316,   316,   316,   316,   316,   316,   316,
     316,   316,   316,   316,   316,   316,   316,   316,   316,   316,
     316,   316,   317,   317,   317,   317,   317,   317,   317,   317,
     317,   317,   318,   318,   318,   318,   318,   318,   318,   318,
     318,   318,   318,   318,   318,   319,   319,   319,   319,   319,
     319,   319,   320,   320,   320,   320,   320,   321,   321,   321,
     321,   322,   322,   322,   323,   323,   323,   324,   324,   324,
     325,   325,   325,   326,   326,   326,   327,   327,   327,   328,
     328,   328,   329,   329,   329,   330,   330,   330,   331,   331,
     331,   332,   332,   332,   333,   333,   333,   334,   334,   334,
     335,   335,   335,   336,   336,   336,   337,   337,   337,   338,
     338,   338,   339,   339,   339,   340,   340,   340,   341,   341,
     341,   342,   342,   342,   343,   343,   343,   344,   344,   344,
     345,   345,   345,   346,   346,   346,   347,   347,   347,   348,
     348,   348,   349,   349,   349,   350,   350,   350,   351,   351,
     351,   352,   352,   352,   353,   353,   353,   354,   354,   354,
     355,   355,   355,   356,   356,   356,   357,   357,   357,   358,
     358,   358,   359,   359,   359,   360,   360,   360,   361,   361,
     361,   362,   362,   362,   363,   363,   363,   364,   364,   367,
     368,   369,   370,   373,   374,   380,   383,   386,   389,   392,
     395,   398,   401,   404,   407,   410,   413,   416,   419,   422,
     425,   428,   431,   434,   437,   440,   443,   446,   449,   452,
     455,   458,   461,   464,   467,   470,   473,   476,   479,   482,
     485,   488,   491,   494,   497,   500,   503,   506,   509,   512,
     515,   518,   521,   524,   527,   530,   533,   536,   539,   542,
     545,   548
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "'#'", "'='", "','", "'''", "'\"'",
  "'.'", "'+'", "'-'", "'0'", "'1'", "'2'", "'3'", "'4'", "'5'", "'6'",
  "'7'", "'8'", "'9'", "'A'", "'B'", "'C'", "'D'", "'E'", "'F'", "'G'",
  "'H'", "'I'", "'J'", "'K'", "'L'", "'M'", "'N'", "'O'", "'P'", "'Q'",
  "'R'", "'S'", "'T'", "'U'", "'V'", "'W'", "'X'", "'Y'", "'Z'", "'a'",
  "'b'", "'c'", "'d'", "'e'", "'f'", "'g'", "'h'", "'i'", "'j'", "'k'",
  "'l'", "'m'", "'n'", "'o'", "'p'", "'q'", "'r'", "'s'", "'t'", "'u'",
  "'v'", "'w'", "'x'", "'y'", "'z'", "'!'", "'$'", "'%'", "'&'", "'('",
  "')'", "'*'", "'/'", "':'", "';'", "'<'", "'>'", "'?'", "'@'", "'['",
  "'\\\\'", "']'", "'^'", "'_'", "'{'", "'|'", "'}'", "'~'", "'\\200'",
  "'\\201'", "'\\202'", "'\\203'", "'\\204'", "'\\205'", "'\\206'",
  "'\\207'", "'\\210'", "'\\211'", "'\\212'", "'\\213'", "'\\214'",
  "'\\215'", "'\\216'", "'\\217'", "'\\220'", "'\\221'", "'\\222'",
  "'\\223'", "'\\224'", "'\\225'", "'\\226'", "'\\227'", "'\\230'",
  "'\\231'", "'\\232'", "'\\233'", "'\\234'", "'\\235'", "'\\236'",
  "'\\237'", "'\\240'", "'\\241'", "'\\242'", "'\\243'", "'\\244'",
  "'\\245'", "'\\246'", "'\\247'", "'\\250'", "'\\251'", "'\\252'",
  "'\\253'", "'\\254'", "'\\255'", "'\\256'", "'\\257'", "'\\260'",
  "'\\261'", "'\\262'", "'\\263'", "'\\264'", "'\\265'", "'\\266'",
  "'\\267'", "'\\270'", "'\\271'", "'\\272'", "'\\273'", "'\\274'",
  "'\\275'", "'\\276'", "'\\277'", "'\\300'", "'\\301'", "'\\302'",
  "'\\303'", "'\\304'", "'\\305'", "'\\306'", "'\\307'", "'\\310'",
  "'\\311'", "'\\312'", "'\\313'", "'\\314'", "'\\315'", "'\\316'",
  "'\\317'", "'\\320'", "'\\321'", "'\\322'", "'\\323'", "'\\324'",
  "'\\325'", "'\\326'", "'\\327'", "'\\330'", "'\\331'", "'\\332'",
  "'\\333'", "'\\334'", "'\\335'", "'\\336'", "'\\337'", "'\\340'",
  "'\\341'", "'\\342'", "'\\343'", "'\\344'", "'\\345'", "'\\346'",
  "'\\347'", "'\\350'", "'\\351'", "'\\352'", "'\\353'", "'\\354'",
  "'\\355'", "'\\356'", "'\\357'", "'\\360'", "'\\361'", "'\\362'",
  "'\\363'", "'\\364'", "'\\365'", "'\\366'", "'\\367'", "'\\370'",
  "'\\371'", "'\\372'", "'\\373'", "'\\374'", "'\\375'", "'\\376'",
  "'\\377'", "' '", "'\\n'", "'\\r'", "$accept", "input", "line",
  "comment", "command", "subscribe_event", "unsubscribe_event",
  "get_instruction", "set_instruction", "create_instruction",
  "destroy_instruction", "load_instruction", "set_chan_instruction",
  "key_val_list", "buffer_size_type", "list_instruction",
  "load_instr_args", "load_engine_args", "device_index",
  "audio_channel_index", "audio_output_type_name", "midi_input_port_index",
  "midi_input_channel_index", "midi_input_type_name", "volume_value",
  "sampler_channel", "instrument_index", "engine_name", "filename",
  "param_val_list", "param_val", "boolean", "string", "dotnum", "digits",
  "digit", "number", "char", "text", "stringval", "SP", "LF", "CR", "ADD",
  "GET", "CREATE", "DESTROY", "LIST", "LOAD", "ALL", "NON_MODAL", "REMOVE",
  "SET", "SUBSCRIBE", "UNSUBSCRIBE", "SELECT", "CHANNEL",
  "AVAILABLE_ENGINES", "AVAILABLE_AUDIO_OUTPUT_DRIVERS", "CHANNELS",
  "INFO", "CHANNEL_COUNT", "CHANNEL_INFO", "BUFFER_FILL", "STREAM_COUNT",
  "VOICE_COUNT", "INSTRUMENT", "ENGINE", "AUDIO_OUTPUT_DEVICE_PARAMETER",
  "AUDIO_OUTPUT_DEVICES", "AUDIO_OUTPUT_DEVICE",
  "AUDIO_OUTPUT_DRIVER_PARAMETER", "AUDIO_OUTPUT_DRIVER",
  "AUDIO_OUTPUT_CHANNEL_PARAMETER", "AUDIO_OUTPUT_CHANNEL",
  "AUDIO_OUTPUT_TYPE", "AVAILABLE_MIDI_INPUT_DRIVERS",
  "MIDI_INPUT_DEVICE_PARAMETER", "MIDI_INPUT_PORT_PARAMETER",
  "MIDI_INPUT_DEVICES", "MIDI_INPUT_DEVICE", "MIDI_INPUT_DRIVER_PARAMETER",
  "MIDI_INPUT_DRIVER", "MIDI_INPUT_PORT", "MIDI_INPUT_CHANNEL",
  "MIDI_INPUT_TYPE", "MIDI_INPUT", "SERVER", "VOLUME", "MUTE", "SOLO",
  "BYTES", "PERCENTAGE", "RESET", "MISCELLANEOUS", "ECHO", "QUIT", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,    35,    61,    44,    39,    34,    46,    43,
      45,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,    33,    36,    37,    38,    40,    41,    42,
      47,    58,    59,    60,    62,    63,    64,    91,    92,    93,
      94,    95,   123,   124,   125,   126,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,    32,    10,    13
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned short int yyr1[] =
{
       0,   227,   228,   228,   229,   229,   229,   229,   230,   230,
     230,   230,   230,   231,   231,   231,   231,   231,   231,   231,
     231,   231,   231,   231,   231,   231,   231,   232,   232,   232,
     232,   232,   232,   233,   233,   233,   233,   233,   233,   234,
     234,   234,   234,   234,   234,   234,   234,   234,   234,   234,
     234,   234,   234,   234,   234,   234,   234,   234,   234,   234,
     234,   234,   234,   235,   235,   235,   235,   235,   235,   236,
     236,   236,   236,   237,   237,   238,   238,   239,   239,   239,
     239,   239,   239,   239,   239,   239,   239,   239,   240,   240,
     241,   241,   242,   242,   242,   242,   242,   242,   243,   243,
     244,   245,   246,   247,   248,   249,   249,   250,   251,   251,
     252,   253,   254,   255,   256,   256,   257,   257,   257,   257,
     257,   258,   258,   259,   259,   260,   260,   260,   261,   261,
     262,   262,   262,   262,   262,   262,   262,   262,   262,   262,
     263,   263,   263,   263,   263,   263,   263,   263,   263,   263,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   265,
     265,   265,   265,   266,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     2,     3,     0,     1,     1,     1,     1,     2,
       2,     2,     2,     3,     3,     3,     3,     3,     3,     5,
       3,     3,     3,     3,     5,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     5,     7,     9,     1,     5,     7,     9,     1,     1,
       5,     5,     7,     9,     7,     9,     1,     5,     7,     5,
       5,     5,     3,     7,     9,     7,     9,     3,     3,     5,
       3,     5,     3,     3,     3,     3,     3,     5,     7,     5,
       9,     5,     5,     5,     5,     5,     5,     5,     3,     5,
       1,     1,     1,     1,     1,     1,     1,     1,     5,     7,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     3,     3,     1,
       1,     1,     1,     1,     2,     3,     4,     4,     1,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     3,     3,     1,     1,     1,     3,     3,
       6,     7,     4,     4,     3,     9,     6,     3,     9,    11,
       6,     7,    17,    30,     8,     4,    13,    12,    11,    12,
      11,    10,     6,    29,    20,    19,    29,    19,    30,    20,
      17,    28,    27,    25,    18,    17,    27,    17,    15,    18,
      15,    10,     6,     6,     4,     4,     5,    10,     5,    13,
       4,     4
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned short int yydefact[] =
{
       0,     7,     8,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     5,     6,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    25,    26,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       1,   376,   377,     2,     0,     9,   228,   223,   222,   220,
     221,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   212,   214,   215,   216,   217,   218,   219,
     224,   225,   226,   227,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   375,    12,   140,    11,   123,    10,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   378,     0,     0,   379,     0,     0,     0,     0,
       0,     0,   387,     0,     0,     3,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   141,   128,   142,   143,
     144,   145,   146,   147,   148,   149,   213,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   124,     0,    13,
       0,     0,     0,     0,     0,    14,     0,    39,    44,    56,
       0,    48,     0,     0,     0,     0,     0,    40,     0,    49,
       0,     0,     0,     0,     0,     0,     0,    15,     0,     0,
      16,     0,     0,     0,     0,     0,    17,    95,    97,    94,
      92,    96,    93,     0,    18,     0,     0,     0,     0,     0,
       0,    20,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    21,    27,    31,    30,    29,    28,    32,
      22,    33,    37,    36,    35,    34,    38,   370,    23,   369,
       0,     0,     0,   382,   383,   431,     0,     0,     0,     0,
       0,   129,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   372,
     371,     0,     0,     0,     0,   428,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    62,     0,     0,    70,    72,   131,   132,   133,
     134,   135,   136,   137,   138,   139,    73,    74,     0,     0,
       0,     0,     0,     0,     0,    75,     0,   113,     0,    76,
       0,   112,    19,   110,     0,     0,     0,     0,     0,     0,
       0,    67,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    68,   122,   121,
       0,     0,     0,     0,     0,    24,   380,     0,   386,   390,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     430,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   381,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    57,     0,
       0,     0,    90,    91,    59,    60,    61,    50,     0,    45,
       0,     0,     0,    51,     0,    41,     0,     0,     0,    69,
       0,    71,     0,     0,     0,     0,   373,   374,     0,     0,
     111,     0,   100,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   402,     0,   422,   395,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   424,   425,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   388,     0,   391,
       0,     0,   391,     0,     0,     0,    58,    46,     0,    54,
       0,    42,    52,     0,     0,     0,     0,     0,   220,   221,
      88,   114,   116,   120,     0,   128,   119,     0,     0,     0,
       0,     0,    98,     0,     0,     0,     0,     0,     0,    77,
     101,     0,   102,    79,   103,    81,    82,   104,     0,    83,
     105,   106,    84,   107,     0,     0,     0,    85,   108,   109,
      86,    87,    63,     0,    65,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   394,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     423,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   389,     0,     0,     0,   426,     0,    47,    55,    53,
      43,     0,     0,    89,   117,   118,     0,     0,   115,   125,
       0,     0,     0,     0,    99,     0,     0,     0,     0,    78,
     384,     0,    64,    66,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   126,   127,     0,     0,
     401,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   385,     0,     0,     0,     0,    80,   398,
       0,     0,     0,     0,   400,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     421,     0,   397,     0,   399,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   396,   429,     0,     0,     0,     0,     0,     0,
       0,     0,   427,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   418,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   392,     0,   415,   417,     0,     0,   415,     0,     0,
       0,     0,     0,     0,     0,     0,   418,   420,     0,     0,
       0,     0,     0,   414,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   405,   407,     0,     0,     0,
       0,   405,     0,     0,     0,     0,     0,   410,     0,   409,
     404,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     419,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   409,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     413,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   416,     0,   412,     0,     0,     0,
     411,     0,     0,   406,     0,   403,   408,   393
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short int yydefgoto[] =
{
      -1,    12,    13,    14,    15,   393,   400,   335,   381,   357,
     360,   374,   541,   669,   651,   366,   525,   529,   809,   811,
     813,   816,   819,   822,   827,   532,   679,   530,   526,   790,
     791,   557,   792,   793,   794,   266,   533,   268,   408,   527,
     731,    43,    44,    16,    17,    18,    19,    20,    21,   821,
     528,    22,    23,    24,    25,    26,   329,   337,   338,   339,
     487,   394,   395,   396,   397,   398,   375,   340,   383,   341,
     342,   343,   344,   345,   346,   544,   347,   385,   348,   349,
     350,   351,   352,   353,   547,   548,   549,   354,   550,   551,
     552,   652,   653,    27,   399,   387,    28
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -735
static const short int yypact[] =
{
      51,  -735,  -735,     9,    20,    36,    92,     5,    95,   137,
       0,   104,   185,  -194,  1600,  -735,   -38,   -38,   -38,   -38,
     -38,   -38,   -38,   -38,   -38,   -38,   -38,   -38,  -735,   173,
     180,   162,   167,   169,   188,   221,    -4,    -2,   229,   213,
    -735,  -735,  -735,  -735,    39,  -735,  -735,  -735,  -735,  -735,
    -735,  -735,   243,   243,   243,   243,   243,   243,   243,   243,
     243,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,
    -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,
    -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,
    -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,
    -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,
    -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,
    -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,
    -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,
    -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,
    -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,
    -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,
    -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,
    -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,
    -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,
    -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,
    -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,
    -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,
    -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,
    -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,
    -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,
    -735,  -735,  -735,  -735,  -735,  2707,  -735,  -735,  -735,  -735,
     247,    77,    86,    86,    76,    83,   247,   177,    54,    54,
    1822,   247,  -735,   245,   231,  -735,   232,   249,   234,   240,
     263,   264,  -735,   251,   250,  -735,  -735,  -735,  -735,  -735,
    -735,  -735,  -735,  -735,  -735,  -735,   243,  -735,   243,   243,
     243,   243,   243,   243,   243,   243,  -735,  -735,  -735,  -735,
    -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,   265,  -735,
      38,   266,   258,   268,   270,  -735,   -38,  -735,  -735,  -735,
     -38,  -735,   -38,   -38,   -38,   -38,   -38,  -735,   -38,  -735,
     -38,   -38,   -38,   -38,   -38,   269,   277,  -735,   -38,   -38,
    -735,   -38,   -38,    44,   279,   280,  -735,  -735,  -735,  -735,
    -735,  -735,  -735,   274,  -735,   -38,   -38,   -38,   271,   288,
     284,  -735,   -38,   -38,   -38,   -38,   -38,   -38,   273,   287,
     289,   276,   282,  -735,  -735,  -735,  -735,  -735,  -735,  -735,
    -735,  -735,  -735,  -735,  -735,  -735,  -735,  2707,  1822,  -735,
     -38,   285,   281,  -735,  -735,  -735,   278,   286,   299,   301,
     306,  -735,   313,   312,   321,   322,   317,   323,   314,    62,
     324,   324,   324,   324,   324,   324,   324,   324,   324,   324,
     324,   324,   326,   327,  2707,  2707,   267,   267,   330,   334,
     332,   318,    21,  2707,   267,   335,   333,   336,    18,   267,
     267,   267,   267,  2928,   339,   337,   328,   338,   346,  2707,
    -735,   267,   341,   342,   343,  -735,   340,   344,   345,   347,
     349,   350,   351,   354,   357,   348,   353,   -38,   -38,   -38,
     -38,   -38,   -38,   -38,   -38,   -38,   -38,   -38,   -38,   -38,
     -38,   -38,  -735,   359,   360,  1822,  1822,   243,   243,   243,
     243,   243,   243,   243,   243,   243,  -735,  -735,   362,   358,
     364,   361,  1822,  1822,   363,  -735,   -38,  -735,   -38,  -735,
     -38,  2707,  -735,  -735,   365,   367,   370,   366,    74,   369,
     371,  -735,   -38,   -38,   -38,   -38,   -38,   -38,   -38,   -38,
     -38,   -38,   -38,   -38,   -38,   -38,   -38,  -735,  2707,  -735,
     374,   375,   382,   383,   387,  -735,  -735,   368,  -735,  -735,
     385,   388,   378,   380,   384,   386,   389,   331,   392,   393,
     267,    37,   267,   267,  2707,   267,  2707,  2707,   267,   267,
     267,   267,  2707,  2707,   267,   390,   352,  2707,  2707,   391,
     394,   372,   396,  1156,  1378,   395,   267,   154,   267,   400,
    -735,   373,   397,   403,   398,   399,   404,   267,   267,   267,
     267,   267,   267,   267,   267,   267,   267,   267,  2707,   267,
    2707,   267,   405,   406,   412,   418,   416,  -735,   402,   413,
     417,   376,   423,   425,   427,   424,   419,   420,  -735,   409,
     431,   -38,  -735,  -735,  -735,  -735,  -735,  -735,  1822,  2707,
     -38,   -38,   -38,  -735,  1822,  2707,   -38,   377,   429,   -38,
    3149,   -38,   379,   434,   432,   421,  -735,  -735,   381,   -38,
    -735,   -38,  -735,   415,   436,   437,   440,   435,   438,   430,
     -38,   -38,   -38,   -38,   -38,   -38,   -38,   -38,   -38,   -38,
     -38,  3370,   -38,  3591,   -38,   451,   465,   459,   461,   453,
     470,   467,   475,   473,   489,   480,  -735,   482,  -735,  -735,
     474,   490,   267,  2707,   267,   267,   267,  2707,   267,   492,
     512,  2707,  2044,   513,   515,   516,   518,   519,   267,   267,
     514,   520,   521,   462,  -735,  -735,   522,   267,   267,  2707,
     267,   267,   228,  2707,   267,   203,  2928,  2928,  2044,  2707,
    2044,  2707,   466,   526,   527,   469,   538,  -735,   540,  -735,
     523,   531,   528,   529,   541,   545,  -735,  1822,   -38,  -735,
     -38,  1822,  -735,   532,   533,  3812,  2707,  2707,   243,   243,
     565,  -735,  2707,  -735,   113,    12,  -735,   537,   528,   536,
     554,   546,  -735,   -38,   542,   548,   491,   556,   561,  -735,
    -735,   -38,  -735,  -735,  2707,  -735,  -735,  -735,   557,  -735,
    -735,  -735,  -735,  2707,   -38,   243,   243,  -735,  -735,  -735,
    -735,  -735,   565,  4033,   565,  4254,   562,   502,   573,   572,
     563,   571,   559,   575,  -735,   560,   558,   577,  2707,  2707,
    2707,  2707,   564,   567,  2044,  2265,  2486,   163,   176,  2044,
     243,   566,   568,   569,   581,   267,   570,   578,   576,   579,
    -735,   267,   580,   267,  2044,  2044,   585,    33,   582,   583,
     584,  -735,   586,   530,   587,  -735,   589,   -38,  2707,  2707,
     -38,   588,   590,   565,  -735,  -735,   243,   243,  -735,   243,
     592,   591,   593,   599,  -735,   596,   594,   595,   601,  -735,
    -735,   -38,   565,   565,   597,   600,   605,   615,   609,   607,
     611,   178,   535,   602,   613,   555,   243,   243,   614,   574,
    -735,   624,   616,   603,   618,   619,   228,   627,   620,   636,
     628,   630,   631,   632,   626,   639,   641,    99,   653,   635,
     652,   648,   666,  -735,   655,   110,   656,   657,  -735,  -735,
     659,   663,   658,   660,  -735,   610,   678,   676,   680,    56,
     670,   679,   617,   682,   622,   684,   625,   692,   685,   683,
     637,   681,  -735,   687,  -735,   121,   690,   694,   698,   688,
     700,   693,   707,   711,   697,   723,   712,   141,   713,   715,
     709,    82,  -735,  -735,   728,    57,   722,   724,   668,   732,
     720,   726,  -735,   738,   740,   746,   743,   745,   749,   747,
     735,   686,   752,   748,   736,   761,   744,   756,   696,   763,
     760,   768,   767,   702,   753,   771,   759,   781,   784,   764,
     786,   702,    13,   789,   769,   776,   779,   785,   775,   783,
     780,   787,   795,   788,   791,   793,   798,   796,   799,   794,
     802,   807,   805,   790,   800,   803,   813,   808,   823,   826,
     811,  -735,   817,   815,   765,   834,   835,  -735,   839,   815,
     829,   843,   777,   846,   833,   836,  -735,  -735,   847,   848,
     837,   838,   840,  -735,   841,   842,   849,   851,   854,   857,
     852,   850,   858,   860,   863,   853,   806,   865,   856,   869,
     881,  -735,   853,   871,   818,   885,   878,  -735,   882,   822,
    -735,   884,   877,   830,   886,   892,   822,   890,   889,   903,
    -735,   893,   910,   894,   908,   912,   911,   917,   918,   909,
     919,   904,   855,   905,   914,   913,   906,   915,  -735,   907,
     928,   926,   922,   929,   930,   935,   932,   937,   927,   921,
     920,   923,   931,   933,   924,   934,   940,   939,   945,   947,
    -735,   949,   950,   951,   938,   941,   942,   943,   944,   948,
     952,   954,   957,   946,  -735,   962,  -735,   963,   953,   958,
    -735,   959,   960,  -735,   956,  -735,  -735,  -735
};

/* YYPGOTO[NTERM-NUM].  */
static const short int yypgoto[] =
{
    -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,
    -735,  -735,  -735,  -583,  -735,  -735,  -735,  -735,  -591,  -453,
    -735,   116,    41,  -735,  -735,  -469,   260,   422,   401,  -734,
     131,  -589,   307,   246,    11,   -10,   -14,   138,  -353,  -735,
     -13,   961,  -735,  -735,  -735,  -735,  -735,  -735,  -735,  -735,
    -735,  -735,  -735,  -735,  -735,  -735,  -134,   729,   730,   733,
    -206,   721,   731,  -263,  -257,  -256,  -735,   727,  -735,   737,
    -254,  -735,  -735,   739,   551,  -735,   741,  -735,   742,   750,
    -252,  -735,  -735,   604,  -735,  -735,  -735,  -735,  -735,  -735,
    -735,  -735,  -735,  -735,   734,  -735,  -735
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -141
static const short int yytable[] =
{
     267,   269,   565,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   671,   403,  -140,   358,   361,
     359,   362,   404,   405,   832,    37,   834,   522,   523,   289,
     291,    41,    42,    29,    33,   290,  1062,  1013,   292,   537,
      34,    38,   307,   307,   307,   307,   307,   307,   307,   307,
     307,   538,     1,  1063,     2,   524,   915,   539,    30,   649,
     540,    31,   916,   306,   308,   309,   310,   311,   312,   313,
     314,   315,     3,   650,     4,     5,   388,   389,     6,   423,
     424,   989,  1026,     7,   388,   448,   424,   390,     8,     9,
      10,   486,    11,   391,   990,  1027,   392,   363,   330,   364,
     331,   391,   332,   613,   392,  1022,   973,   355,   332,   365,
     333,   648,   373,   654,   655,   614,   334,    32,  1023,   356,
     893,   860,  1024,   969,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   977,   970,    35,   336,    39,   682,
     912,   913,   377,   382,  1004,  1005,   978,   410,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   815,
     522,   523,    36,   824,  1017,  1018,   488,   830,   831,   603,
     604,   896,   489,   490,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   897,    40,   264,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   282,   378,   944,
     328,   284,   379,   945,   542,   283,   545,   285,   286,   287,
     380,   946,   825,   826,   296,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,  -140,  -140,  -140,   296,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   818,
     288,   293,   294,   776,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,    41,   887,   411,   409,   890,   802,
     328,   412,   413,   414,   415,   416,    -4,    -4,   296,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   417,   418,
     419,   420,   426,   422,   425,   428,   421,   427,   421,   421,
     421,   421,   421,   421,   421,   421,   443,   449,   451,   450,
     442,   456,   455,   457,   464,   465,   467,   468,   466,   473,
     474,   265,   476,   429,   477,   472,   475,   430,   478,   431,
     432,   433,   434,   435,   479,   436,   480,   437,   438,   439,
     440,   441,   481,   482,   483,   444,   445,   484,   446,   447,
     503,   504,   485,   486,   518,   519,   520,   521,   561,   534,
     536,   535,   452,   453,   454,   560,   566,   562,   568,   458,
     459,   460,   461,   462,   463,   564,   563,   567,   573,   574,
     569,   572,   570,   576,   571,   575,   577,   579,   595,   596,
     578,   599,   600,   601,   609,   470,   904,   471,   605,   611,
     632,   602,   610,   327,   615,   634,   616,   612,   635,   633,
     636,   639,   640,   637,   638,   641,   642,   646,   909,   647,
     643,   685,   645,   644,   710,   667,   672,   686,   673,   678,
     705,   688,   516,   517,   675,   683,   689,   707,   687,   708,
     706,   709,   712,   668,   714,   553,   554,   555,   556,   559,
     715,   711,   716,   717,   720,   719,   721,   718,   730,   734,
     744,   735,   736,   674,   684,   741,   742,   713,   729,   743,
     733,   746,   737,   745,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   762,
     763,   764,   597,   598,   765,   767,   768,   307,   307,   307,
     307,   307,   307,   307,   307,   307,   740,   769,   770,   409,
     409,   771,   772,   606,   774,   607,   773,   608,   306,   308,
     309,   310,   311,   312,   313,   314,   315,   783,   775,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   766,   327,   784,   798,   797,   804,
     799,   800,   801,   807,   805,   808,   806,   836,   837,   838,
     839,   840,   841,   843,   842,   845,   846,   844,   847,   853,
     859,   657,   862,   852,   660,   661,   662,   663,   861,   863,
     666,   864,   868,   866,   867,   869,   870,   407,   876,   872,
     470,   470,   680,   877,   878,   879,   881,   885,   880,   882,
     883,   884,   886,   902,   891,   903,   900,   327,   892,   901,
     905,   907,   910,   908,   914,   702,   917,   704,   918,   906,
     931,   921,   920,   923,   924,   919,   947,   922,   928,   937,
     925,   929,   932,   930,   933,   938,   934,   935,   722,   939,
     940,   942,   948,   327,   327,   723,   950,   724,   725,   726,
     941,   727,   943,   728,   949,   951,   953,   954,   956,   959,
     957,   960,   961,   962,   963,   952,   738,   966,   739,   327,
     968,   964,   965,   967,   971,   972,   973,   747,   748,   749,
     750,   751,   752,   753,   754,   755,   756,   757,   974,   759,
     975,   761,   979,   981,   955,   976,   327,   980,   982,   983,
     984,   985,   986,   987,   988,   991,   992,   994,   993,   996,
     778,   779,   780,   995,   782,   469,   997,   998,   796,  1006,
     999,  1002,   795,  1007,  1000,   680,  1003,  1008,  1001,  1010,
    1009,  1011,  1012,   810,   812,  1013,   810,   817,   820,  1014,
     810,   829,   559,   559,   796,   795,   796,  1015,   795,  1021,
     795,   505,   506,  1020,  1016,  1019,  1025,  1028,  1029,  1030,
     531,  1031,  1032,  1034,   848,   849,  1033,   850,   851,  1035,
     558,  1036,  1037,  1038,  1039,  1041,  1040,  1042,   307,   307,
    1043,  1045,  1046,  1044,   421,  1048,  1047,  1049,  1050,  1051,
     865,  1052,  1053,  1054,  1056,  1055,   327,   327,   871,   857,
     858,  1057,   327,   327,  1058,  1059,  1060,  1065,   327,  1061,
    1064,   873,  1066,  1067,  1068,   307,   307,  1069,  1070,  1071,
    1073,  1072,  1076,  1077,  1079,  1078,  1074,  1075,  1080,   407,
     407,  1081,  1082,  1083,  1085,  1084,   857,   858,  1087,   327,
     796,   327,  1088,  1086,   795,   796,  1089,   421,   421,   795,
     307,  1090,  1091,  1092,  1093,  1095,  1094,   812,  1096,   817,
     796,   796,  1097,  1098,   795,   795,  1099,  1101,  1100,  1102,
    1103,   899,  1104,  1105,  1111,  1106,  1112,  1109,  1107,  1113,
    1110,  1108,  1114,  1117,  1116,  1118,   307,   307,  1115,   421,
    1124,   531,  1120,   658,   659,  1119,  1123,  1121,   936,   664,
     665,  1122,  1125,  1126,   670,   670,  1128,   926,   927,  1127,
     469,   469,  1129,  1131,  1130,   327,   421,   421,  1133,   327,
    1132,  1134,   820,   327,  1135,  1136,  1137,  1138,  1139,  1140,
     327,  1141,  1143,  1144,  1142,   701,  1145,   703,  1146,  1147,
    1149,  1148,  1150,  1152,  1155,  1157,  1151,  1153,  1156,  1158,
    1159,  1160,   327,  1154,  1161,  1162,  1163,  1164,  1165,  1167,
    1166,   327,  1168,  1169,  1172,  1174,  1171,  1173,  1175,  1170,
    1176,   327,  1177,   327,  1178,  1179,  1180,   958,  1181,  1188,
    1183,  1184,  1189,  1182,  1185,  1190,  1186,  1191,  1192,   911,
     898,  1193,  1187,   327,   327,  1197,  1194,  1195,  1196,   803,
     401,   828,   376,   367,   368,   295,   656,   369,   681,   543,
     402,   370,     0,   406,     0,   371,   384,     0,     0,   386,
       0,     0,     0,     0,   372,     0,   327,   327,     0,     0,
     777,     0,     0,     0,   781,     0,     0,     0,   785,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   814,     0,     0,     0,
     823,     0,   546,   558,   558,     0,   833,     0,   835,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   855,   856,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   670,   888,   889,   670,   316,
      46,    47,   676,     0,    48,    49,    50,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   316,    46,    47,     0,   677,    48,    49,    50,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,    45,    46,    47,     0,     0,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   316,    46,    47,     0,     0,
      48,    49,    50,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   316,    46,    47,
     786,   787,    48,   788,   789,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   316,    46,
      47,   894,     0,    48,    49,    50,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   316,
      46,    47,     0,   895,    48,    49,    50,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     316,    46,    47,     0,     0,    48,    49,    50,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   316,    46,    47,     0,     0,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   316,   732,    47,     0,     0,    48,    49,    50,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   316,   758,    47,     0,     0,    48,    49,
      50,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   316,   760,    47,     0,     0,    48,
      49,    50,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   316,   854,    47,     0,     0,
      48,    49,    50,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   316,   874,    47,     0,
       0,    48,    49,    50,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   316,   875,    47,
       0,     0,    48,    49,    50,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263
};

static const short int yycheck[] =
{
      14,    14,   471,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,   598,   279,     5,   272,   273,
     272,   273,   279,   279,   758,    25,   760,     6,     7,    33,
      32,   225,   226,    24,    29,    39,    23,    24,    40,    21,
      35,    41,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    33,     1,    40,     3,    34,    23,    39,    38,    22,
      42,    25,    29,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    21,    36,    23,    24,    22,    23,    27,    41,
      42,    25,    25,    32,    22,    41,    42,    33,    37,    38,
      39,    29,    41,    39,    38,    38,    42,    21,    21,    23,
      23,    39,    25,    29,    42,    23,    24,    21,    25,    33,
      33,   580,    29,   582,   583,    41,    39,    25,    36,    33,
     854,     8,    40,    24,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    24,    36,    41,   271,    34,   608,
     874,   875,   276,   277,    23,    24,    36,   281,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   750,
       6,     7,    25,   754,    23,    24,   429,   756,   757,   522,
     523,     8,   429,   429,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,     8,     0,   224,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    24,    21,    21,
      23,    39,    25,    25,   458,    25,   458,    40,    39,    21,
      33,    33,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   224,   225,   226,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      29,    22,    39,   722,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,   225,   848,    21,   280,   851,   738,
      23,    40,    40,    24,    40,    35,   225,   226,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    25,    25,
      39,    41,    34,    28,    28,    25,   306,    29,   308,   309,
     310,   311,   312,   313,   314,   315,    29,    28,    34,    29,
      41,    23,    41,    29,    41,    28,    40,    35,    29,    38,
      42,    14,    23,   336,    23,    40,    40,   340,    22,   342,
     343,   344,   345,   346,    21,   348,    24,   350,   351,   352,
     353,   354,    21,    21,    27,   358,   359,    24,   361,   362,
      24,    24,    38,    29,    24,    21,    24,    39,    21,    24,
      24,    28,   375,   376,   377,    26,    25,    39,    25,   382,
     383,   384,   385,   386,   387,    29,    38,    35,    29,    29,
      40,    34,    38,    29,    39,    34,    29,    34,    29,    29,
      42,    29,    34,    29,    29,   408,   865,   410,    35,    29,
      26,    40,    35,   265,    35,    23,    35,    41,    25,    34,
      23,    23,    34,    45,    29,    35,    32,    25,   871,    26,
      34,    24,    91,    34,    22,    35,    35,    24,    34,    34,
      25,    32,   446,   447,    38,    35,    32,    25,    40,    21,
      34,    25,    25,    91,    21,   459,   460,   461,   462,   463,
      25,    38,    25,    29,    45,    35,    25,    38,    29,    25,
      25,    29,    41,    91,    91,    29,    29,    91,    91,    29,
      91,    41,    91,    35,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,    38,
      25,    32,   505,   506,    33,    25,    29,   507,   508,   509,
     510,   511,   512,   513,   514,   515,    91,    32,    35,   522,
     523,    22,    32,   526,    40,   528,    34,   530,   507,   508,
     509,   510,   511,   512,   513,   514,   515,    35,    38,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,    91,   407,    34,    32,    35,    35,
      34,    33,    33,    91,    34,    33,    35,    91,    32,    32,
      91,    23,    22,    32,    41,    36,    25,    39,    23,    36,
       5,   585,    36,    41,   588,   589,   590,   591,    41,    25,
     594,    35,    91,    41,    36,    29,    25,   280,    26,    32,
     603,   604,   606,    91,    21,    23,    25,    39,    35,    40,
      25,    41,    25,    34,    40,    24,    40,   469,    41,    41,
      40,    35,    32,    34,    29,   629,    34,   631,    35,    41,
      21,    91,    36,    34,    36,    41,    91,    40,    36,    32,
      40,    40,    36,    40,    40,    35,    41,    36,   651,    34,
      25,    34,    40,   505,   506,   658,    91,   660,   661,   662,
      41,   664,    41,   666,    41,    41,    32,    41,    40,    32,
      41,    41,    26,    35,    34,    91,   679,    41,   681,   531,
      29,    40,    40,    34,    21,    40,    24,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,    40,   702,
      24,   704,    36,    34,    91,    40,   558,    40,    35,    41,
      40,    91,    24,    27,    24,    35,    27,    25,    91,    25,
     724,   725,   726,    91,   728,   408,    91,    25,   732,    29,
      35,    40,   732,    29,    41,   739,    39,    29,    91,    29,
      42,    38,    25,   747,   748,    24,   750,   751,   752,    42,
     754,   755,   756,   757,   758,   755,   760,    24,   758,    40,
     760,   444,   445,    38,    42,    42,    28,    35,    34,    91,
     453,    29,    42,    25,   777,   778,    40,   780,   781,    29,
     463,    25,    29,    28,    25,    40,    29,    91,   788,   789,
      28,    45,    21,    35,   794,    29,    42,    91,    25,    29,
     803,    23,    25,    91,    23,    42,   658,   659,   811,   788,
     789,    42,   664,   665,    23,    21,    42,    38,   670,    23,
      21,   824,    36,    34,    29,   825,   826,    42,    35,    39,
      25,    34,    29,    25,    25,    29,    38,    36,    34,   522,
     523,    29,    25,    28,    34,    45,   825,   826,    25,   701,
     854,   703,    34,    40,   854,   859,    23,   857,   858,   859,
     860,    25,    41,    36,    39,    21,    91,   871,    23,   873,
     874,   875,    23,    34,   874,   875,    23,    21,    91,    36,
      34,   860,    25,    25,    25,    38,    25,    36,    40,    25,
      38,    41,    25,    25,    34,    25,   896,   897,    36,   899,
      21,   584,    39,   586,   587,    32,    40,    91,   911,   592,
     593,    36,    21,    32,   597,   598,    21,   896,   897,    91,
     603,   604,    34,    91,    32,   777,   926,   927,    41,   781,
      36,    91,   936,   785,    38,    33,    36,    38,    25,    36,
     792,    21,    24,    21,    40,   628,    25,   630,    21,    21,
      21,    32,    38,    38,    38,    38,    91,    33,    33,    21,
      24,    29,   814,    40,    25,    25,    21,    25,    21,    38,
      33,   823,    42,    40,    40,    25,    33,    33,    29,    38,
      25,   833,    25,   835,    25,    25,    25,   936,    40,    25,
      38,    38,    25,    42,    40,    39,    38,    25,    25,   873,
     859,    38,    40,   855,   856,    39,    38,    38,    38,   739,
     279,   755,   275,   274,   274,    44,   584,   274,   607,   458,
     279,   274,    -1,   279,    -1,   274,   277,    -1,    -1,   277,
      -1,    -1,    -1,    -1,   274,    -1,   888,   889,    -1,    -1,
     723,    -1,    -1,    -1,   727,    -1,    -1,    -1,   731,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   749,    -1,    -1,    -1,
     753,    -1,   458,   756,   757,    -1,   759,    -1,   761,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   786,   787,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   848,   849,   850,   851,     3,
       4,     5,     6,    -1,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,     3,     4,     5,    -1,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,     3,     4,     5,    -1,    -1,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,     3,     4,     5,    -1,    -1,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,     3,     4,
       5,     6,    -1,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,     3,
       4,     5,    -1,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
       3,     4,     5,    -1,    -1,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,     3,     4,     5,    -1,    -1,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,     3,     4,     5,    -1,    -1,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,     3,     4,     5,    -1,    -1,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,     3,     4,     5,    -1,    -1,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,     3,     4,     5,    -1,    -1,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,     3,     4,     5,    -1,
      -1,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,     3,     4,     5,
      -1,    -1,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned short int yystos[] =
{
       0,     1,     3,    21,    23,    24,    27,    32,    37,    38,
      39,    41,   228,   229,   230,   231,   270,   271,   272,   273,
     274,   275,   278,   279,   280,   281,   282,   320,   323,    24,
      38,    25,    25,    29,    35,    41,    25,    25,    41,    34,
       0,   225,   226,   268,   269,     3,     4,     5,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   259,   262,   263,   264,   267,
     267,   267,   267,   267,   267,   267,   267,   267,   267,   267,
     267,   267,    24,    25,    39,    40,    39,    21,    29,    33,
      39,    32,    40,    22,    39,   268,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,   261,   262,   261,   261,
     261,   261,   261,   261,   261,   261,     3,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,   264,    23,   283,
      21,    23,    25,    33,    39,   234,   283,   284,   285,   286,
     294,   296,   297,   298,   299,   300,   301,   303,   305,   306,
     307,   308,   309,   310,   314,    21,    33,   236,   297,   307,
     237,   297,   307,    21,    23,    33,   242,   284,   285,   286,
     296,   303,   306,    29,   238,   293,   294,   283,    21,    25,
      33,   235,   283,   295,   300,   304,   305,   322,    22,    23,
      33,    39,    42,   232,   288,   289,   290,   291,   292,   321,
     233,   288,   289,   290,   291,   292,   321,   259,   265,   267,
     283,    21,    40,    40,    24,    40,    35,    25,    25,    39,
      41,   262,    28,    41,    42,    28,    34,    29,    25,   267,
     267,   267,   267,   267,   267,   267,   267,   267,   267,   267,
     267,   267,    41,    29,   267,   267,   267,   267,    41,    28,
      29,    34,   267,   267,   267,    41,    23,    29,   267,   267,
     267,   267,   267,   267,    41,    28,    29,    40,    35,   259,
     267,   267,    40,    38,    42,    40,    23,    23,    22,    21,
      24,    21,    21,    27,    24,    38,    29,   287,   290,   291,
     292,   287,   287,   287,   287,   287,   287,   287,   287,   287,
     287,   287,   287,    24,    24,   259,   259,    12,    13,    14,
      15,    16,    17,    18,    19,    20,   263,   263,    24,    21,
      24,    39,     6,     7,    34,   243,   255,   266,   277,   244,
     254,   259,   252,   263,    24,    28,    24,    21,    33,    39,
      42,   239,   297,   301,   302,   307,   310,   311,   312,   313,
     315,   316,   317,   263,   263,   263,   263,   258,   259,   263,
      26,    21,    39,    38,    29,   252,    25,    35,    25,    40,
      38,    39,    34,    29,    29,    34,    29,    29,    42,    34,
     267,   267,   267,   267,   267,   267,   267,   267,   267,   267,
     267,   267,   267,   267,   267,    29,    29,   267,   267,    29,
      34,    29,    40,   265,   265,    35,   267,   267,   267,    29,
      35,    29,    41,    29,    41,    35,    35,   267,   267,   267,
     267,   267,   267,   267,   267,   267,   267,   267,   267,   267,
     267,   267,    26,    34,    23,    25,    23,    45,    29,    23,
      34,    35,    32,    34,    34,    91,    25,    26,   252,    22,
      36,   241,   318,   319,   252,   252,   254,   263,   259,   259,
     263,   263,   263,   263,   259,   259,   263,    35,    91,   240,
     259,   240,    35,    34,    91,    38,     6,     7,    34,   253,
     263,   255,   252,    35,    91,    24,    24,    40,    32,    32,
     252,   252,   252,   252,   252,   252,   252,   252,   252,   252,
     252,   259,   263,   259,   263,    25,    34,    25,    21,    25,
      22,    38,    25,    91,    21,    25,    25,    29,    38,    35,
      45,    25,   267,   267,   267,   267,   267,   267,   267,    91,
      29,   267,     4,    91,    25,    29,    41,    91,   267,   267,
      91,    29,    29,    29,    25,    35,    41,   267,   267,   267,
     267,   267,   267,   267,   267,   267,   267,   267,     4,   267,
       4,   267,    38,    25,    32,    33,    91,    25,    29,    32,
      35,    22,    32,    34,    40,    38,   252,   259,   263,   263,
     263,   259,   263,    35,    34,   259,     6,     7,     9,    10,
     256,   257,   259,   260,   261,   262,   263,    35,    32,    34,
      33,    33,   252,   253,    35,    34,    35,    91,    33,   245,
     263,   246,   263,   247,   259,   245,   248,   263,    21,   249,
     263,   276,   250,   259,   245,     9,    10,   251,   260,   263,
     258,   258,   256,   259,   256,   259,    91,    32,    32,    91,
      23,    22,    41,    32,    39,    36,    25,    23,   267,   267,
     267,   267,    41,    36,     4,   259,   259,   261,   261,     5,
       8,    41,    36,    25,    35,   267,    41,    36,    91,    29,
      25,   267,    32,   267,     4,     4,    26,    91,    21,    23,
      35,    25,    40,    25,    41,    39,    25,   240,   259,   259,
     240,    40,    41,   256,     6,     7,     8,     8,   257,   261,
      40,    41,    34,    24,   252,    40,    41,    35,    34,   246,
      32,   248,   256,   256,    29,    23,    29,    34,    35,    41,
      36,    91,    40,    34,    36,    40,   261,   261,    36,    40,
      40,    21,    36,    40,    41,    36,   267,    32,    35,    34,
      25,    41,    34,    41,    21,    25,    33,    91,    40,    41,
      91,    41,    91,    32,    41,    91,    40,    41,   249,    32,
      41,    26,    35,    34,    40,    40,    41,    34,    29,    24,
      36,    21,    40,    24,    40,    24,    40,    24,    36,    36,
      40,    34,    35,    41,    40,    91,    24,    27,    24,    25,
      38,    35,    27,    91,    25,    91,    25,    91,    25,    35,
      41,    91,    40,    39,    23,    24,    29,    29,    29,    42,
      29,    38,    25,    24,    42,    24,    42,    23,    24,    42,
      38,    40,    23,    36,    40,    28,    25,    38,    35,    34,
      91,    29,    42,    40,    25,    29,    25,    29,    28,    25,
      29,    40,    91,    28,    35,    45,    21,    42,    29,    91,
      25,    29,    23,    25,    91,    42,    23,    42,    23,    21,
      42,    23,    23,    40,    21,    38,    36,    34,    29,    42,
      35,    39,    34,    25,    38,    36,    29,    25,    29,    25,
      34,    29,    25,    28,    45,    34,    40,    25,    34,    23,
      25,    41,    36,    39,    91,    21,    23,    23,    34,    23,
      91,    21,    36,    34,    25,    25,    38,    40,    41,    36,
      38,    25,    25,    25,    25,    36,    34,    25,    25,    32,
      39,    91,    36,    40,    21,    21,    32,    91,    21,    34,
      32,    91,    36,    41,    91,    38,    33,    36,    38,    25,
      36,    21,    40,    24,    21,    25,    21,    21,    32,    21,
      38,    91,    38,    33,    40,    38,    33,    38,    21,    24,
      29,    25,    25,    21,    25,    21,    33,    38,    42,    40,
      38,    33,    40,    33,    25,    29,    25,    25,    25,    25,
      25,    40,    42,    38,    38,    40,    38,    40,    25,    25,
      39,    25,    25,    38,    38,    38,    38,    39
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (N)								\
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (0)
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
              (Loc).first_line, (Loc).first_column,	\
              (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Type, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);


# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */






/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  /* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  register short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;


  yyvsp[0] = yylval;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a look-ahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to look-ahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 4:
#line 94 "lscp.y"
    { return LSCP_DONE; }
    break;

  case 5:
#line 95 "lscp.y"
    { return LSCP_DONE; }
    break;

  case 6:
#line 96 "lscp.y"
    { LSCPSERVER->AnswerClient((yyvsp[0].String)); return LSCP_DONE; }
    break;

  case 7:
#line 97 "lscp.y"
    { LSCPSERVER->AnswerClient("ERR:0:Unknown command.\r\n"); RESTART; return LSCP_SYNTAX_ERROR; }
    break;

  case 13:
#line 107 "lscp.y"
    { (yyval.String) = LSCPSERVER->AddChannel();                          }
    break;

  case 14:
#line 108 "lscp.y"
    { (yyval.String) = (yyvsp[0].String);                                                }
    break;

  case 15:
#line 109 "lscp.y"
    { (yyval.String) = (yyvsp[0].String);                                                }
    break;

  case 16:
#line 110 "lscp.y"
    { (yyval.String) = (yyvsp[0].String);                                                }
    break;

  case 17:
#line 111 "lscp.y"
    { (yyval.String) = (yyvsp[0].String);                                                }
    break;

  case 18:
#line 112 "lscp.y"
    { (yyval.String) = (yyvsp[0].String);                                                }
    break;

  case 19:
#line 113 "lscp.y"
    { (yyval.String) = LSCPSERVER->RemoveChannel((yyvsp[0].Number));                     }
    break;

  case 20:
#line 114 "lscp.y"
    { (yyval.String) = (yyvsp[0].String);                                                }
    break;

  case 21:
#line 115 "lscp.y"
    { (yyval.String) = (yyvsp[0].String);                                                }
    break;

  case 22:
#line 116 "lscp.y"
    { (yyval.String) = (yyvsp[0].String);                                                }
    break;

  case 23:
#line 117 "lscp.y"
    { (yyval.String) = LSCPSERVER->QueryDatabase((yyvsp[0].String));                     }
    break;

  case 24:
#line 118 "lscp.y"
    { (yyval.String) = LSCPSERVER->ResetChannel((yyvsp[0].Number));                      }
    break;

  case 25:
#line 119 "lscp.y"
    { (yyval.String) = LSCPSERVER->ResetSampler();                        }
    break;

  case 26:
#line 120 "lscp.y"
    { LSCPSERVER->AnswerClient("Bye!\r\n"); return LSCP_QUIT; }
    break;

  case 27:
#line 123 "lscp.y"
    { (yyval.String) = LSCPSERVER->SubscribeNotification(LSCPEvent::event_channel_count); }
    break;

  case 28:
#line 124 "lscp.y"
    { (yyval.String) = LSCPSERVER->SubscribeNotification(LSCPEvent::event_voice_count);   }
    break;

  case 29:
#line 125 "lscp.y"
    { (yyval.String) = LSCPSERVER->SubscribeNotification(LSCPEvent::event_stream_count);  }
    break;

  case 30:
#line 126 "lscp.y"
    { (yyval.String) = LSCPSERVER->SubscribeNotification(LSCPEvent::event_buffer_fill);   }
    break;

  case 31:
#line 127 "lscp.y"
    { (yyval.String) = LSCPSERVER->SubscribeNotification(LSCPEvent::event_channel_info);  }
    break;

  case 32:
#line 128 "lscp.y"
    { (yyval.String) = LSCPSERVER->SubscribeNotification(LSCPEvent::event_misc);          }
    break;

  case 33:
#line 131 "lscp.y"
    { (yyval.String) = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_channel_count); }
    break;

  case 34:
#line 132 "lscp.y"
    { (yyval.String) = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_voice_count);   }
    break;

  case 35:
#line 133 "lscp.y"
    { (yyval.String) = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_stream_count);  }
    break;

  case 36:
#line 134 "lscp.y"
    { (yyval.String) = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_buffer_fill);   }
    break;

  case 37:
#line 135 "lscp.y"
    { (yyval.String) = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_channel_info);  }
    break;

  case 38:
#line 136 "lscp.y"
    { (yyval.String) = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_misc);          }
    break;

  case 39:
#line 139 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetAvailableEngines();                          }
    break;

  case 40:
#line 140 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetAvailableMidiInputDrivers();                 }
    break;

  case 41:
#line 141 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetMidiInputDriverInfo((yyvsp[0].String));                     }
    break;

  case 42:
#line 142 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetMidiInputDriverParameterInfo((yyvsp[-2].String), (yyvsp[0].String));        }
    break;

  case 43:
#line 143 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetMidiInputDriverParameterInfo((yyvsp[-4].String), (yyvsp[-2].String), (yyvsp[0].KeyValList));    }
    break;

  case 44:
#line 144 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetAvailableAudioOutputDrivers();               }
    break;

  case 45:
#line 145 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetAudioOutputDriverInfo((yyvsp[0].String));                   }
    break;

  case 46:
#line 146 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetAudioOutputDriverParameterInfo((yyvsp[-2].String), (yyvsp[0].String));      }
    break;

  case 47:
#line 147 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetAudioOutputDriverParameterInfo((yyvsp[-4].String), (yyvsp[-2].String), (yyvsp[0].KeyValList));  }
    break;

  case 48:
#line 148 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetAudioOutputDeviceCount();                    }
    break;

  case 49:
#line 149 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetMidiInputDeviceCount();                      }
    break;

  case 50:
#line 150 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetAudioOutputDeviceInfo((yyvsp[0].Number));                   }
    break;

  case 51:
#line 151 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetMidiInputDeviceInfo((yyvsp[0].Number));                     }
    break;

  case 52:
#line 152 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetMidiInputPortInfo((yyvsp[-2].Number), (yyvsp[0].Number));                   }
    break;

  case 53:
#line 153 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetMidiInputPortParameterInfo((yyvsp[-4].Number), (yyvsp[-2].Number), (yyvsp[0].String));      }
    break;

  case 54:
#line 154 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetAudioOutputChannelInfo((yyvsp[-2].Number), (yyvsp[0].Number));              }
    break;

  case 55:
#line 155 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetAudioOutputChannelParameterInfo((yyvsp[-4].Number), (yyvsp[-2].Number), (yyvsp[0].String)); }
    break;

  case 56:
#line 156 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetChannels();                                  }
    break;

  case 57:
#line 157 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetChannelInfo((yyvsp[0].Number));                             }
    break;

  case 58:
#line 158 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetBufferFill((yyvsp[-2].FillResponse), (yyvsp[0].Number));                          }
    break;

  case 59:
#line 159 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetStreamCount((yyvsp[0].Number));                             }
    break;

  case 60:
#line 160 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetVoiceCount((yyvsp[0].Number));                              }
    break;

  case 61:
#line 161 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetEngineInfo((yyvsp[0].String));                              }
    break;

  case 62:
#line 162 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetServerInfo();                                }
    break;

  case 63:
#line 165 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetAudioOutputDeviceParameter((yyvsp[-4].Number), (yyvsp[-2].String), (yyvsp[0].String));      }
    break;

  case 64:
#line 166 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetAudioOutputChannelParameter((yyvsp[-6].Number), (yyvsp[-4].Number), (yyvsp[-2].String), (yyvsp[0].String)); }
    break;

  case 65:
#line 167 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetMidiInputDeviceParameter((yyvsp[-4].Number), (yyvsp[-2].String), (yyvsp[0].String));        }
    break;

  case 66:
#line 168 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetMidiInputPortParameter((yyvsp[-6].Number), (yyvsp[-4].Number), (yyvsp[-2].String), (yyvsp[0].String));      }
    break;

  case 67:
#line 169 "lscp.y"
    { (yyval.String) = (yyvsp[0].String);                                                         }
    break;

  case 68:
#line 170 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetEcho((yyparse_param_t*) yyparse_param, (yyvsp[0].Dotnum));  }
    break;

  case 69:
#line 173 "lscp.y"
    { (yyval.String) = LSCPSERVER->CreateAudioOutputDevice((yyvsp[-2].String),(yyvsp[0].KeyValList)); }
    break;

  case 70:
#line 174 "lscp.y"
    { (yyval.String) = LSCPSERVER->CreateAudioOutputDevice((yyvsp[0].String));    }
    break;

  case 71:
#line 175 "lscp.y"
    { (yyval.String) = LSCPSERVER->CreateMidiInputDevice((yyvsp[-2].String),(yyvsp[0].KeyValList));   }
    break;

  case 72:
#line 176 "lscp.y"
    { (yyval.String) = LSCPSERVER->CreateMidiInputDevice((yyvsp[0].String));      }
    break;

  case 73:
#line 179 "lscp.y"
    { (yyval.String) = LSCPSERVER->DestroyAudioOutputDevice((yyvsp[0].Number)); }
    break;

  case 74:
#line 180 "lscp.y"
    { (yyval.String) = LSCPSERVER->DestroyMidiInputDevice((yyvsp[0].Number));   }
    break;

  case 75:
#line 183 "lscp.y"
    { (yyval.String) = (yyvsp[0].String); }
    break;

  case 76:
#line 184 "lscp.y"
    { (yyval.String) = (yyvsp[0].String); }
    break;

  case 77:
#line 187 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetAudioOutputDevice((yyvsp[0].Number), (yyvsp[-2].Number));      }
    break;

  case 78:
#line 188 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetAudioOutputChannel((yyvsp[-2].Number), (yyvsp[0].Number), (yyvsp[-4].Number)); }
    break;

  case 79:
#line 189 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetAudioOutputType((yyvsp[0].String), (yyvsp[-2].Number));        }
    break;

  case 80:
#line 190 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetMIDIInput((yyvsp[-4].Number), (yyvsp[-2].Number), (yyvsp[0].Number), (yyvsp[-6].Number));      }
    break;

  case 81:
#line 191 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetMIDIInputDevice((yyvsp[0].Number), (yyvsp[-2].Number));        }
    break;

  case 82:
#line 192 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetMIDIInputPort((yyvsp[0].Number), (yyvsp[-2].Number));          }
    break;

  case 83:
#line 193 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetMIDIInputChannel((yyvsp[0].Number), (yyvsp[-2].Number));       }
    break;

  case 84:
#line 194 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetMIDIInputType((yyvsp[0].String), (yyvsp[-2].Number));          }
    break;

  case 85:
#line 195 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetVolume((yyvsp[0].Dotnum), (yyvsp[-2].Number));                 }
    break;

  case 86:
#line 196 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetChannelMute((yyvsp[0].Dotnum), (yyvsp[-2].Number));            }
    break;

  case 87:
#line 197 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetChannelSolo((yyvsp[0].Dotnum), (yyvsp[-2].Number));            }
    break;

  case 88:
#line 200 "lscp.y"
    { (yyval.KeyValList)[(yyvsp[-2].String)] = (yyvsp[0].String);          }
    break;

  case 89:
#line 201 "lscp.y"
    { (yyval.KeyValList) = (yyvsp[-4].KeyValList); (yyval.KeyValList)[(yyvsp[-2].String)] = (yyvsp[0].String); }
    break;

  case 90:
#line 204 "lscp.y"
    { (yyval.FillResponse) = fill_response_bytes;      }
    break;

  case 91:
#line 205 "lscp.y"
    { (yyval.FillResponse) = fill_response_percentage; }
    break;

  case 92:
#line 208 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetAudioOutputDevices();           }
    break;

  case 93:
#line 209 "lscp.y"
    { (yyval.String) = LSCPSERVER->GetMidiInputDevices();             }
    break;

  case 94:
#line 210 "lscp.y"
    { (yyval.String) = LSCPSERVER->ListChannels();                    }
    break;

  case 95:
#line 211 "lscp.y"
    { (yyval.String) = LSCPSERVER->ListAvailableEngines();            }
    break;

  case 96:
#line 212 "lscp.y"
    { (yyval.String) = LSCPSERVER->ListAvailableMidiInputDrivers();   }
    break;

  case 97:
#line 213 "lscp.y"
    { (yyval.String) = LSCPSERVER->ListAvailableAudioOutputDrivers(); }
    break;

  case 98:
#line 216 "lscp.y"
    { (yyval.String) = LSCPSERVER->LoadInstrument((yyvsp[-4].String), (yyvsp[-2].Number), (yyvsp[0].Number));       }
    break;

  case 99:
#line 217 "lscp.y"
    { (yyval.String) = LSCPSERVER->LoadInstrument((yyvsp[-4].String), (yyvsp[-2].Number), (yyvsp[0].Number), true); }
    break;

  case 100:
#line 220 "lscp.y"
    { (yyval.String) = LSCPSERVER->SetEngineType((yyvsp[-2].String), (yyvsp[0].Number)); }
    break;

  case 106:
#line 236 "lscp.y"
    { (yyval.Number) = 16; }
    break;

  case 109:
#line 243 "lscp.y"
    { (yyval.Dotnum) = (yyvsp[0].Number); }
    break;

  case 115:
#line 259 "lscp.y"
    { (yyval.String) = (yyvsp[-2].String) + "," + (yyvsp[0].String); }
    break;

  case 117:
#line 263 "lscp.y"
    { (yyval.String) = "\'" + (yyvsp[-1].String) + "\'"; }
    break;

  case 118:
#line 264 "lscp.y"
    { (yyval.String) = "\"" + (yyvsp[-1].String) + "\""; }
    break;

  case 119:
#line 265 "lscp.y"
    { std::stringstream ss; ss << "\'" << (yyvsp[0].Number) << "\'"; (yyval.String) = ss.str(); }
    break;

  case 120:
#line 266 "lscp.y"
    { std::stringstream ss; ss << "\'" << (yyvsp[0].Dotnum) << "\'"; (yyval.String) = ss.str(); }
    break;

  case 121:
#line 274 "lscp.y"
    { (yyval.Dotnum) = (yyvsp[0].Number); }
    break;

  case 122:
#line 275 "lscp.y"
    { (yyval.Dotnum) = -1; }
    break;

  case 123:
#line 278 "lscp.y"
    { std::string s; s = (yyvsp[0].Char); (yyval.String) = s; }
    break;

  case 124:
#line 279 "lscp.y"
    { (yyval.String) = (yyvsp[-1].String) + (yyvsp[0].Char);                  }
    break;

  case 125:
#line 282 "lscp.y"
    { (yyval.Dotnum) = atof(String((yyvsp[-2].String) + "." + (yyvsp[0].String)).c_str());                         }
    break;

  case 126:
#line 283 "lscp.y"
    { String s = "+"; s += (yyvsp[-2].String); s += "."; s += (yyvsp[0].String); (yyval.Dotnum) = atof(s.c_str()); }
    break;

  case 127:
#line 284 "lscp.y"
    { (yyval.Dotnum) = atof(String("-" + (yyvsp[-2].String) + "." + (yyvsp[0].String)).c_str());                   }
    break;

  case 128:
#line 288 "lscp.y"
    { (yyval.String) = (yyvsp[0].Char);      }
    break;

  case 129:
#line 289 "lscp.y"
    { (yyval.String) = (yyvsp[-1].String) + (yyvsp[0].Char); }
    break;

  case 130:
#line 292 "lscp.y"
    { (yyval.Char) = '0'; }
    break;

  case 131:
#line 293 "lscp.y"
    { (yyval.Char) = '1'; }
    break;

  case 132:
#line 294 "lscp.y"
    { (yyval.Char) = '2'; }
    break;

  case 133:
#line 295 "lscp.y"
    { (yyval.Char) = '3'; }
    break;

  case 134:
#line 296 "lscp.y"
    { (yyval.Char) = '4'; }
    break;

  case 135:
#line 297 "lscp.y"
    { (yyval.Char) = '5'; }
    break;

  case 136:
#line 298 "lscp.y"
    { (yyval.Char) = '6'; }
    break;

  case 137:
#line 299 "lscp.y"
    { (yyval.Char) = '7'; }
    break;

  case 138:
#line 300 "lscp.y"
    { (yyval.Char) = '8'; }
    break;

  case 139:
#line 301 "lscp.y"
    { (yyval.Char) = '9'; }
    break;

  case 140:
#line 304 "lscp.y"
    { (yyval.Number) = atoi(String(1, (yyvsp[0].Char)).c_str());      }
    break;

  case 141:
#line 305 "lscp.y"
    { (yyval.Number) = atoi(String(String("1") + (yyvsp[0].String)).c_str()); }
    break;

  case 142:
#line 306 "lscp.y"
    { (yyval.Number) = atoi(String(String("2") + (yyvsp[0].String)).c_str()); }
    break;

  case 143:
#line 307 "lscp.y"
    { (yyval.Number) = atoi(String(String("3") + (yyvsp[0].String)).c_str()); }
    break;

  case 144:
#line 308 "lscp.y"
    { (yyval.Number) = atoi(String(String("4") + (yyvsp[0].String)).c_str()); }
    break;

  case 145:
#line 309 "lscp.y"
    { (yyval.Number) = atoi(String(String("5") + (yyvsp[0].String)).c_str()); }
    break;

  case 146:
#line 310 "lscp.y"
    { (yyval.Number) = atoi(String(String("6") + (yyvsp[0].String)).c_str()); }
    break;

  case 147:
#line 311 "lscp.y"
    { (yyval.Number) = atoi(String(String("7") + (yyvsp[0].String)).c_str()); }
    break;

  case 148:
#line 312 "lscp.y"
    { (yyval.Number) = atoi(String(String("8") + (yyvsp[0].String)).c_str()); }
    break;

  case 149:
#line 313 "lscp.y"
    { (yyval.Number) = atoi(String(String("9") + (yyvsp[0].String)).c_str()); }
    break;

  case 150:
#line 315 "lscp.y"
    { (yyval.Char) = 'A'; }
    break;

  case 151:
#line 315 "lscp.y"
    { (yyval.Char) = 'B'; }
    break;

  case 152:
#line 315 "lscp.y"
    { (yyval.Char) = 'C'; }
    break;

  case 153:
#line 315 "lscp.y"
    { (yyval.Char) = 'D'; }
    break;

  case 154:
#line 315 "lscp.y"
    { (yyval.Char) = 'E'; }
    break;

  case 155:
#line 315 "lscp.y"
    { (yyval.Char) = 'F'; }
    break;

  case 156:
#line 315 "lscp.y"
    { (yyval.Char) = 'G'; }
    break;

  case 157:
#line 315 "lscp.y"
    { (yyval.Char) = 'H'; }
    break;

  case 158:
#line 315 "lscp.y"
    { (yyval.Char) = 'I'; }
    break;

  case 159:
#line 315 "lscp.y"
    { (yyval.Char) = 'J'; }
    break;

  case 160:
#line 315 "lscp.y"
    { (yyval.Char) = 'K'; }
    break;

  case 161:
#line 315 "lscp.y"
    { (yyval.Char) = 'L'; }
    break;

  case 162:
#line 315 "lscp.y"
    { (yyval.Char) = 'M'; }
    break;

  case 163:
#line 315 "lscp.y"
    { (yyval.Char) = 'N'; }
    break;

  case 164:
#line 315 "lscp.y"
    { (yyval.Char) = 'O'; }
    break;

  case 165:
#line 315 "lscp.y"
    { (yyval.Char) = 'P'; }
    break;

  case 166:
#line 315 "lscp.y"
    { (yyval.Char) = 'Q'; }
    break;

  case 167:
#line 315 "lscp.y"
    { (yyval.Char) = 'R'; }
    break;

  case 168:
#line 315 "lscp.y"
    { (yyval.Char) = 'S'; }
    break;

  case 169:
#line 315 "lscp.y"
    { (yyval.Char) = 'T'; }
    break;

  case 170:
#line 315 "lscp.y"
    { (yyval.Char) = 'U'; }
    break;

  case 171:
#line 315 "lscp.y"
    { (yyval.Char) = 'V'; }
    break;

  case 172:
#line 315 "lscp.y"
    { (yyval.Char) = 'W'; }
    break;

  case 173:
#line 315 "lscp.y"
    { (yyval.Char) = 'X'; }
    break;

  case 174:
#line 315 "lscp.y"
    { (yyval.Char) = 'Y'; }
    break;

  case 175:
#line 315 "lscp.y"
    { (yyval.Char) = 'Z'; }
    break;

  case 176:
#line 316 "lscp.y"
    { (yyval.Char) = 'a'; }
    break;

  case 177:
#line 316 "lscp.y"
    { (yyval.Char) = 'b'; }
    break;

  case 178:
#line 316 "lscp.y"
    { (yyval.Char) = 'c'; }
    break;

  case 179:
#line 316 "lscp.y"
    { (yyval.Char) = 'd'; }
    break;

  case 180:
#line 316 "lscp.y"
    { (yyval.Char) = 'e'; }
    break;

  case 181:
#line 316 "lscp.y"
    { (yyval.Char) = 'f'; }
    break;

  case 182:
#line 316 "lscp.y"
    { (yyval.Char) = 'g'; }
    break;

  case 183:
#line 316 "lscp.y"
    { (yyval.Char) = 'h'; }
    break;

  case 184:
#line 316 "lscp.y"
    { (yyval.Char) = 'i'; }
    break;

  case 185:
#line 316 "lscp.y"
    { (yyval.Char) = 'j'; }
    break;

  case 186:
#line 316 "lscp.y"
    { (yyval.Char) = 'k'; }
    break;

  case 187:
#line 316 "lscp.y"
    { (yyval.Char) = 'l'; }
    break;

  case 188:
#line 316 "lscp.y"
    { (yyval.Char) = 'm'; }
    break;

  case 189:
#line 316 "lscp.y"
    { (yyval.Char) = 'n'; }
    break;

  case 190:
#line 316 "lscp.y"
    { (yyval.Char) = 'o'; }
    break;

  case 191:
#line 316 "lscp.y"
    { (yyval.Char) = 'p'; }
    break;

  case 192:
#line 316 "lscp.y"
    { (yyval.Char) = 'q'; }
    break;

  case 193:
#line 316 "lscp.y"
    { (yyval.Char) = 'r'; }
    break;

  case 194:
#line 316 "lscp.y"
    { (yyval.Char) = 's'; }
    break;

  case 195:
#line 316 "lscp.y"
    { (yyval.Char) = 't'; }
    break;

  case 196:
#line 316 "lscp.y"
    { (yyval.Char) = 'u'; }
    break;

  case 197:
#line 316 "lscp.y"
    { (yyval.Char) = 'v'; }
    break;

  case 198:
#line 316 "lscp.y"
    { (yyval.Char) = 'w'; }
    break;

  case 199:
#line 316 "lscp.y"
    { (yyval.Char) = 'x'; }
    break;

  case 200:
#line 316 "lscp.y"
    { (yyval.Char) = 'y'; }
    break;

  case 201:
#line 316 "lscp.y"
    { (yyval.Char) = 'z'; }
    break;

  case 202:
#line 317 "lscp.y"
    { (yyval.Char) = '0'; }
    break;

  case 203:
#line 317 "lscp.y"
    { (yyval.Char) = '1'; }
    break;

  case 204:
#line 317 "lscp.y"
    { (yyval.Char) = '2'; }
    break;

  case 205:
#line 317 "lscp.y"
    { (yyval.Char) = '3'; }
    break;

  case 206:
#line 317 "lscp.y"
    { (yyval.Char) = '4'; }
    break;

  case 207:
#line 317 "lscp.y"
    { (yyval.Char) = '5'; }
    break;

  case 208:
#line 317 "lscp.y"
    { (yyval.Char) = '6'; }
    break;

  case 209:
#line 317 "lscp.y"
    { (yyval.Char) = '7'; }
    break;

  case 210:
#line 317 "lscp.y"
    { (yyval.Char) = '8'; }
    break;

  case 211:
#line 317 "lscp.y"
    { (yyval.Char) = '9'; }
    break;

  case 212:
#line 318 "lscp.y"
    { (yyval.Char) = '!'; }
    break;

  case 213:
#line 318 "lscp.y"
    { (yyval.Char) = '#'; }
    break;

  case 214:
#line 318 "lscp.y"
    { (yyval.Char) = '$'; }
    break;

  case 215:
#line 318 "lscp.y"
    { (yyval.Char) = '%'; }
    break;

  case 216:
#line 318 "lscp.y"
    { (yyval.Char) = '&'; }
    break;

  case 217:
#line 318 "lscp.y"
    { (yyval.Char) = '('; }
    break;

  case 218:
#line 318 "lscp.y"
    { (yyval.Char) = ')'; }
    break;

  case 219:
#line 318 "lscp.y"
    { (yyval.Char) = '*'; }
    break;

  case 220:
#line 318 "lscp.y"
    { (yyval.Char) = '+'; }
    break;

  case 221:
#line 318 "lscp.y"
    { (yyval.Char) = '-'; }
    break;

  case 222:
#line 318 "lscp.y"
    { (yyval.Char) = '.'; }
    break;

  case 223:
#line 318 "lscp.y"
    { (yyval.Char) = ','; }
    break;

  case 224:
#line 318 "lscp.y"
    { (yyval.Char) = '/'; }
    break;

  case 225:
#line 319 "lscp.y"
    { (yyval.Char) = ':'; }
    break;

  case 226:
#line 319 "lscp.y"
    { (yyval.Char) = ';'; }
    break;

  case 227:
#line 319 "lscp.y"
    { (yyval.Char) = '<'; }
    break;

  case 228:
#line 319 "lscp.y"
    { (yyval.Char) = '='; }
    break;

  case 229:
#line 319 "lscp.y"
    { (yyval.Char) = '>'; }
    break;

  case 230:
#line 319 "lscp.y"
    { (yyval.Char) = '?'; }
    break;

  case 231:
#line 319 "lscp.y"
    { (yyval.Char) = '@'; }
    break;

  case 232:
#line 320 "lscp.y"
    { (yyval.Char) = '['; }
    break;

  case 233:
#line 320 "lscp.y"
    { (yyval.Char) = '\\'; }
    break;

  case 234:
#line 320 "lscp.y"
    { (yyval.Char) = ']'; }
    break;

  case 235:
#line 320 "lscp.y"
    { (yyval.Char) = '^'; }
    break;

  case 236:
#line 320 "lscp.y"
    { (yyval.Char) = '_'; }
    break;

  case 237:
#line 321 "lscp.y"
    { (yyval.Char) = '{'; }
    break;

  case 238:
#line 321 "lscp.y"
    { (yyval.Char) = '|'; }
    break;

  case 239:
#line 321 "lscp.y"
    { (yyval.Char) = '}'; }
    break;

  case 240:
#line 321 "lscp.y"
    { (yyval.Char) = '~'; }
    break;

  case 241:
#line 322 "lscp.y"
    { (yyval.Char) = '\200'; }
    break;

  case 242:
#line 322 "lscp.y"
    { (yyval.Char) = '\201'; }
    break;

  case 243:
#line 322 "lscp.y"
    { (yyval.Char) = '\202'; }
    break;

  case 244:
#line 323 "lscp.y"
    { (yyval.Char) = '\203'; }
    break;

  case 245:
#line 323 "lscp.y"
    { (yyval.Char) = '\204'; }
    break;

  case 246:
#line 323 "lscp.y"
    { (yyval.Char) = '\205'; }
    break;

  case 247:
#line 324 "lscp.y"
    { (yyval.Char) = '\206'; }
    break;

  case 248:
#line 324 "lscp.y"
    { (yyval.Char) = '\207'; }
    break;

  case 249:
#line 324 "lscp.y"
    { (yyval.Char) = '\210'; }
    break;

  case 250:
#line 325 "lscp.y"
    { (yyval.Char) = '\211'; }
    break;

  case 251:
#line 325 "lscp.y"
    { (yyval.Char) = '\212'; }
    break;

  case 252:
#line 325 "lscp.y"
    { (yyval.Char) = '\213'; }
    break;

  case 253:
#line 326 "lscp.y"
    { (yyval.Char) = '\214'; }
    break;

  case 254:
#line 326 "lscp.y"
    { (yyval.Char) = '\215'; }
    break;

  case 255:
#line 326 "lscp.y"
    { (yyval.Char) = '\216'; }
    break;

  case 256:
#line 327 "lscp.y"
    { (yyval.Char) = '\217'; }
    break;

  case 257:
#line 327 "lscp.y"
    { (yyval.Char) = '\220'; }
    break;

  case 258:
#line 327 "lscp.y"
    { (yyval.Char) = '\221'; }
    break;

  case 259:
#line 328 "lscp.y"
    { (yyval.Char) = '\222'; }
    break;

  case 260:
#line 328 "lscp.y"
    { (yyval.Char) = '\223'; }
    break;

  case 261:
#line 328 "lscp.y"
    { (yyval.Char) = '\224'; }
    break;

  case 262:
#line 329 "lscp.y"
    { (yyval.Char) = '\225'; }
    break;

  case 263:
#line 329 "lscp.y"
    { (yyval.Char) = '\226'; }
    break;

  case 264:
#line 329 "lscp.y"
    { (yyval.Char) = '\227'; }
    break;

  case 265:
#line 330 "lscp.y"
    { (yyval.Char) = '\230'; }
    break;

  case 266:
#line 330 "lscp.y"
    { (yyval.Char) = '\231'; }
    break;

  case 267:
#line 330 "lscp.y"
    { (yyval.Char) = '\232'; }
    break;

  case 268:
#line 331 "lscp.y"
    { (yyval.Char) = '\233'; }
    break;

  case 269:
#line 331 "lscp.y"
    { (yyval.Char) = '\234'; }
    break;

  case 270:
#line 331 "lscp.y"
    { (yyval.Char) = '\235'; }
    break;

  case 271:
#line 332 "lscp.y"
    { (yyval.Char) = '\236'; }
    break;

  case 272:
#line 332 "lscp.y"
    { (yyval.Char) = '\237'; }
    break;

  case 273:
#line 332 "lscp.y"
    { (yyval.Char) = '\240'; }
    break;

  case 274:
#line 333 "lscp.y"
    { (yyval.Char) = '\241'; }
    break;

  case 275:
#line 333 "lscp.y"
    { (yyval.Char) = '\242'; }
    break;

  case 276:
#line 333 "lscp.y"
    { (yyval.Char) = '\243'; }
    break;

  case 277:
#line 334 "lscp.y"
    { (yyval.Char) = '\244'; }
    break;

  case 278:
#line 334 "lscp.y"
    { (yyval.Char) = '\245'; }
    break;

  case 279:
#line 334 "lscp.y"
    { (yyval.Char) = '\246'; }
    break;

  case 280:
#line 335 "lscp.y"
    { (yyval.Char) = '\247'; }
    break;

  case 281:
#line 335 "lscp.y"
    { (yyval.Char) = '\250'; }
    break;

  case 282:
#line 335 "lscp.y"
    { (yyval.Char) = '\251'; }
    break;

  case 283:
#line 336 "lscp.y"
    { (yyval.Char) = '\252'; }
    break;

  case 284:
#line 336 "lscp.y"
    { (yyval.Char) = '\253'; }
    break;

  case 285:
#line 336 "lscp.y"
    { (yyval.Char) = '\254'; }
    break;

  case 286:
#line 337 "lscp.y"
    { (yyval.Char) = '\255'; }
    break;

  case 287:
#line 337 "lscp.y"
    { (yyval.Char) = '\256'; }
    break;

  case 288:
#line 337 "lscp.y"
    { (yyval.Char) = '\257'; }
    break;

  case 289:
#line 338 "lscp.y"
    { (yyval.Char) = '\260'; }
    break;

  case 290:
#line 338 "lscp.y"
    { (yyval.Char) = '\261'; }
    break;

  case 291:
#line 338 "lscp.y"
    { (yyval.Char) = '\262'; }
    break;

  case 292:
#line 339 "lscp.y"
    { (yyval.Char) = '\263'; }
    break;

  case 293:
#line 339 "lscp.y"
    { (yyval.Char) = '\264'; }
    break;

  case 294:
#line 339 "lscp.y"
    { (yyval.Char) = '\265'; }
    break;

  case 295:
#line 340 "lscp.y"
    { (yyval.Char) = '\266'; }
    break;

  case 296:
#line 340 "lscp.y"
    { (yyval.Char) = '\267'; }
    break;

  case 297:
#line 340 "lscp.y"
    { (yyval.Char) = '\270'; }
    break;

  case 298:
#line 341 "lscp.y"
    { (yyval.Char) = '\271'; }
    break;

  case 299:
#line 341 "lscp.y"
    { (yyval.Char) = '\272'; }
    break;

  case 300:
#line 341 "lscp.y"
    { (yyval.Char) = '\273'; }
    break;

  case 301:
#line 342 "lscp.y"
    { (yyval.Char) = '\274'; }
    break;

  case 302:
#line 342 "lscp.y"
    { (yyval.Char) = '\275'; }
    break;

  case 303:
#line 342 "lscp.y"
    { (yyval.Char) = '\276'; }
    break;

  case 304:
#line 343 "lscp.y"
    { (yyval.Char) = '\277'; }
    break;

  case 305:
#line 343 "lscp.y"
    { (yyval.Char) = '\300'; }
    break;

  case 306:
#line 343 "lscp.y"
    { (yyval.Char) = '\301'; }
    break;

  case 307:
#line 344 "lscp.y"
    { (yyval.Char) = '\302'; }
    break;

  case 308:
#line 344 "lscp.y"
    { (yyval.Char) = '\303'; }
    break;

  case 309:
#line 344 "lscp.y"
    { (yyval.Char) = '\304'; }
    break;

  case 310:
#line 345 "lscp.y"
    { (yyval.Char) = '\305'; }
    break;

  case 311:
#line 345 "lscp.y"
    { (yyval.Char) = '\306'; }
    break;

  case 312:
#line 345 "lscp.y"
    { (yyval.Char) = '\307'; }
    break;

  case 313:
#line 346 "lscp.y"
    { (yyval.Char) = '\310'; }
    break;

  case 314:
#line 346 "lscp.y"
    { (yyval.Char) = '\311'; }
    break;

  case 315:
#line 346 "lscp.y"
    { (yyval.Char) = '\312'; }
    break;

  case 316:
#line 347 "lscp.y"
    { (yyval.Char) = '\313'; }
    break;

  case 317:
#line 347 "lscp.y"
    { (yyval.Char) = '\314'; }
    break;

  case 318:
#line 347 "lscp.y"
    { (yyval.Char) = '\315'; }
    break;

  case 319:
#line 348 "lscp.y"
    { (yyval.Char) = '\316'; }
    break;

  case 320:
#line 348 "lscp.y"
    { (yyval.Char) = '\317'; }
    break;

  case 321:
#line 348 "lscp.y"
    { (yyval.Char) = '\320'; }
    break;

  case 322:
#line 349 "lscp.y"
    { (yyval.Char) = '\321'; }
    break;

  case 323:
#line 349 "lscp.y"
    { (yyval.Char) = '\322'; }
    break;

  case 324:
#line 349 "lscp.y"
    { (yyval.Char) = '\323'; }
    break;

  case 325:
#line 350 "lscp.y"
    { (yyval.Char) = '\324'; }
    break;

  case 326:
#line 350 "lscp.y"
    { (yyval.Char) = '\325'; }
    break;

  case 327:
#line 350 "lscp.y"
    { (yyval.Char) = '\326'; }
    break;

  case 328:
#line 351 "lscp.y"
    { (yyval.Char) = '\327'; }
    break;

  case 329:
#line 351 "lscp.y"
    { (yyval.Char) = '\330'; }
    break;

  case 330:
#line 351 "lscp.y"
    { (yyval.Char) = '\331'; }
    break;

  case 331:
#line 352 "lscp.y"
    { (yyval.Char) = '\332'; }
    break;

  case 332:
#line 352 "lscp.y"
    { (yyval.Char) = '\333'; }
    break;

  case 333:
#line 352 "lscp.y"
    { (yyval.Char) = '\334'; }
    break;

  case 334:
#line 353 "lscp.y"
    { (yyval.Char) = '\335'; }
    break;

  case 335:
#line 353 "lscp.y"
    { (yyval.Char) = '\336'; }
    break;

  case 336:
#line 353 "lscp.y"
    { (yyval.Char) = '\337'; }
    break;

  case 337:
#line 354 "lscp.y"
    { (yyval.Char) = '\340'; }
    break;

  case 338:
#line 354 "lscp.y"
    { (yyval.Char) = '\341'; }
    break;

  case 339:
#line 354 "lscp.y"
    { (yyval.Char) = '\342'; }
    break;

  case 340:
#line 355 "lscp.y"
    { (yyval.Char) = '\343'; }
    break;

  case 341:
#line 355 "lscp.y"
    { (yyval.Char) = '\344'; }
    break;

  case 342:
#line 355 "lscp.y"
    { (yyval.Char) = '\345'; }
    break;

  case 343:
#line 356 "lscp.y"
    { (yyval.Char) = '\346'; }
    break;

  case 344:
#line 356 "lscp.y"
    { (yyval.Char) = '\347'; }
    break;

  case 345:
#line 356 "lscp.y"
    { (yyval.Char) = '\350'; }
    break;

  case 346:
#line 357 "lscp.y"
    { (yyval.Char) = '\351'; }
    break;

  case 347:
#line 357 "lscp.y"
    { (yyval.Char) = '\352'; }
    break;

  case 348:
#line 357 "lscp.y"
    { (yyval.Char) = '\353'; }
    break;

  case 349:
#line 358 "lscp.y"
    { (yyval.Char) = '\354'; }
    break;

  case 350:
#line 358 "lscp.y"
    { (yyval.Char) = '\355'; }
    break;

  case 351:
#line 358 "lscp.y"
    { (yyval.Char) = '\356'; }
    break;

  case 352:
#line 359 "lscp.y"
    { (yyval.Char) = '\357'; }
    break;

  case 353:
#line 359 "lscp.y"
    { (yyval.Char) = '\360'; }
    break;

  case 354:
#line 359 "lscp.y"
    { (yyval.Char) = '\361'; }
    break;

  case 355:
#line 360 "lscp.y"
    { (yyval.Char) = '\362'; }
    break;

  case 356:
#line 360 "lscp.y"
    { (yyval.Char) = '\363'; }
    break;

  case 357:
#line 360 "lscp.y"
    { (yyval.Char) = '\364'; }
    break;

  case 358:
#line 361 "lscp.y"
    { (yyval.Char) = '\365'; }
    break;

  case 359:
#line 361 "lscp.y"
    { (yyval.Char) = '\366'; }
    break;

  case 360:
#line 361 "lscp.y"
    { (yyval.Char) = '\367'; }
    break;

  case 361:
#line 362 "lscp.y"
    { (yyval.Char) = '\370'; }
    break;

  case 362:
#line 362 "lscp.y"
    { (yyval.Char) = '\371'; }
    break;

  case 363:
#line 362 "lscp.y"
    { (yyval.Char) = '\372'; }
    break;

  case 364:
#line 363 "lscp.y"
    { (yyval.Char) = '\373'; }
    break;

  case 365:
#line 363 "lscp.y"
    { (yyval.Char) = '\374'; }
    break;

  case 366:
#line 363 "lscp.y"
    { (yyval.Char) = '\375'; }
    break;

  case 367:
#line 364 "lscp.y"
    { (yyval.Char) = '\376'; }
    break;

  case 368:
#line 364 "lscp.y"
    { (yyval.Char) = '\377'; }
    break;

  case 369:
#line 367 "lscp.y"
    { (yyval.String) = " ";      }
    break;

  case 371:
#line 369 "lscp.y"
    { (yyval.String) = (yyvsp[-1].String) + " "; }
    break;

  case 372:
#line 370 "lscp.y"
    { (yyval.String) = (yyvsp[-1].String) + (yyvsp[0].String);  }
    break;

  case 373:
#line 373 "lscp.y"
    { (yyval.String) = (yyvsp[-1].String); }
    break;

  case 374:
#line 374 "lscp.y"
    { (yyval.String) = (yyvsp[-1].String); }
    break;


    }

/* Line 1037 of yacc.c.  */
#line 4468 "y.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {

		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 yydestruct ("Error: popping",
                             yystos[*yyssp], yyvsp);
	       }
        }
      else
	{
	  yydestruct ("Error: discarding", yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping", yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token. */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yydestruct ("Error: discarding lookahead",
              yytoken, &yylval);
  yychar = YYEMPTY;
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 551 "lscp.y"


/**
 * Will be called when an error occured (usually syntax error).
 */
void yyerror(const char* s) {
    dmsg(2,("LSCPParser: %s\n", s));
}

/**
 * Clears input buffer.
 */
void restart(yyparse_param_t* pparam, int& yychar) {
    bytes = 0;
    ptr   = 0;
}


